--  /\
--    Corndog   ޲
--   Editor: v0.1.0  ޲
--     - - - - - -    ޲
--  Darren Hewer 1998 ޲ 
--    Autumn Dreams   ޲         
--   Started: 981024  ޲         
--  Last Edit: 981230 ޲     
--  .\/.                        

----------------------------------------------------------------------------
--==========================================================================
-- Includes

include graphics.e  
include image.e              
include modwave.e
include get.e
include file.e
include dos.e
include wildcard.e
include sort.e

----------------------------------------------------------------------------
-- Setup

without warning
cursor (NO_CURSOR)

----------------------------------------------------------------------------
--==========================================================================
-- Variables

-- Most important sequences ^_-
sequence main, flr, overlay, overlay2, worldinfo, boardinfo   
sequence robocode, roboparam, curr_palette, curr_charset
-- For menu/screen captures (speed, baby!)
sequence color_screen, char_screen, infobar, board_info_screen
sequence add_board_screen, board_selection_screen, worldinfo_screen
sequence worldinfo2_screen, save_scrn, load_scrn, overlay_screen
sequence msgbox_screen, palette_edit_screen, char_edit_screen
sequence clipboard_text, clipboard_color, clipboard_char
global sequence loadfile_screen, ask_screen, default_palette, default_charset
-- Other crud :)
integer cx, cy  -- User's cursor position
integer current_type, current_color, current_bkcolor  -- Current obj 
integer current_board, current_ref  -- *_ref = 0 unless curr obj is robot
integer current_char, current_layer
integer lastcharedit  -- Last char edited by user 
integer drawing                                                 
-- charmaps used for choosing char
sequence charmap, charmap2  -- #2 is in form {x, y}; 1st is 32x8
sequence version, worldheader
object junk, tempseq, original

include darren.e
include charedit.e

----------------------------------------------------------------------------
--==========================================================================
-- Variable Setup

version = "v0.1.0"           
worldheader = "Corndog World File - Do not edit manually! ;)\n"
cx = 1
cy = 1               
current_board = 1                                               
current_type = 1
current_color = 7
current_bkcolor = 0
current_ref = 0     
current_char = 178
roboparam = {}
robocode = {}                        
lastcharedit = 2
-- layers: -1=flr, 0=main, 1=overlay, 2=overlay2             
current_layer = 0
charmap = repeat (repeat (0, 8), 32)  
charmap2 = repeat ({0, 0}, 256)
drawing = 0

----------------------------------------------------------------------------
--==========================================================================
-- Program Procedures / Functions

----------------------------------------------------------------------------
-- save_text_image's screens ... yes, that's a verb. :)
procedure setup_images ()                  
    integer tx, ty       
    set_display_page (1)
    set_active_page (1) 
    printf (1, "Corndog %s\n", {version})
    puts (1, "Loading, please wait ...") 
    set_active_page (0)
    delay (0.2)
    -- Get the 'color choose' screen
    tx = 16 + current_color
    ty = 7 + current_bkcolor   
    colorfill (13, 3, 48, 23, 8) 
    locate (15, 4)
    txt ("@8~FChoose your color")
    locate (15, 5)
    txt ("~7-------")
    locate (34, 10)
    txt ("~AEnter: Select")
    locate (34, 12)
    txt ("~CESC  : Cancel")
    locate (34, 14)
    txt ("~7----")
    locate (tx, ty) 
    -- Show colors ...
    for z = 0 to 15 do
        for p = 0 to 15 do
            locate (z + 16, p + 7)
            set_color (z)
            set_bkcolor (p)
            txt ("")                    
        end for
    end for         
    color_screen = save_text_image ({3, 13}, {23, 48})
    -- Get the 'char choose' screen
    tx = 1
    ty = 1
    colorfill (6, 6, 55, 20, 8)    
    locate (8, 7)
    txt ("@8~FChoose the new character")
    locate (8, 8)
    txt ("~7-------")
    locate (45, 11)
    txt ("~AEnter:")
    locate (45, 12)
    txt ("Select")
    locate (45, 14)
    txt ("~CESC:") 
    locate (45, 15)
    txt ("Cancel")  
    txt ("@8~7")  
    for z = 0 to 255 do  -- Show all chars       
        locate (tx + 7, ty + 9)
        charmap [tx] [ty] = z      
        charmap2 [z + 1] = {tx, ty}
        txt ({z})     
        if tx = 32 then
            tx = 1
            ty = ty + 1
        else
            tx = tx + 1    
        end if 
    end for       
    char_screen = save_text_image ({6, 6}, {20, 55})
    -- The basic sidebar ...
    colorfill (61, 1, 80, 25, 1)
    locate (62, 2)
    txt ("@1~FCorndog Editor")    
    locate (62, 3)
    txt ("@1~9-----")
    locate (74, 4)
    txtf ("~7%s", {version})
    locate (62, 6)
    txt ("@2~0 F1 ~FHelp @3~0 F2 ~FLoad ")
    locate (62, 7)
    txt ("@3~0 F3 ~FSave @2~0 F4 ~FObj  ")  
    locate (62, 9)
    txt ("@2~0 F5 ~FType Text     ")
    locate (62, 10)
    txt ("@3~0 F6 ~FPre-Defined   ")
    locate (62, 20)
    txt ("@1~9-----")
    infobar = save_text_image ({1, 61}, {25, 80})    
    -- The board info editing screen
    colorfill (5, 5, 56, 21, 1)
    locate (7, 6)
    txt ("@1~FBoard Information")                                
    locate (7, 7)
    txt ("@1~9--------") 
    locate (9, 9)
    txt ("@1~FName of Board: @4                         ~F")
    locate (9, 11)
    txt ("@1~FMax Player shots at one time: @4    ")
    locate (9, 13)
    txt ("@1~7")
    txt ({24})
    txt (" ~FExit Up   : @4                         ")
    locate (9, 14)
    txt ("@1~7")
    txt ({25})
    txt (" ~FExit Down : @4                         ")
    locate (9, 15)
    txt ("@1~7")
    txt ({27})
    txt (" ~FExit Left : @4                         ")
    locate (9, 16)       
    txt ("@1~7")
    txt ({26})
    txt (" ~FExit Right: @4                         ")    
    locate (9, 18)
    txt ("@1~FMOD Music File: @4            ")        
    locate (16, 20)
    txt ("@1~AEnter = Change      ~CESC = Exit")
    board_info_screen = save_text_image ({5, 5}, {21, 56})    
    -- Add new board screen
    colorfill (5, 9, 56, 17, 1)
    locate (7, 10)
    txt ("@1~FNew Board")
    locate (7, 11)
    txt ("@1~9--------") 
    locate (43, 15)   
    txt ("@1~CESC = Cancel")
    locate (7, 15)
    txt ("@4~F                         ")    
    add_board_screen = save_text_image ({9, 5}, {17, 56})
    -- Board selection screen
    colorfill (10, 3, 51, 23, 8)
    locate (12, 4)
    txt ("@8~FSelect Board")
    locate (12, 5)    
    txt ("@8~7-------") 
    locate (16, 21)
    txt ("~AEnter = Accept    ~CESC = Cancel~E")
    locate (12, 13)                                    
    txt ({175})
    txt ("                                    ")  
    txt ({174})    
    txt ("@1")
    for z = 8 to 19 do
        locate (17, z)
        txt ("                            ")    
    end for
    board_selection_screen = save_text_image ({3, 10}, {23, 51})
    -- Ask screen
    colorfill (10, 8, 51, 13, 1)
    locate (12, 10)
    txt ("@1~9-------")     
    ask_screen = save_text_image ({8, 10}, {13, 51})    
    -- World info editing screen
    colorfill (5, 2, 56, 24, 1)
    locate (7, 3)
    txt ("@1~FWorld Information: Page #1")
    locate (7, 4)
    txt ("@1~9--------")         
    locate (9, 6)
    txt ("@1~FWorld Name: @4                  ")
    locate (9, 7)
    txt ("@1~FAuthor Name: @4                  ") 
    locate (9, 8)
    txt ("@1~7Last Date Modified: ") 
    locate (9, 10)
    txt ("@1~FPlayer Color: ")
    locate (9, 11)
    txt ("@1~FPlayer Char UP   : ")
    locate (9, 12)
    txt ("@1~FPlayer Char DOWN : ")
    locate (9, 13)
    txt ("@1~FPlayer Char LEFT : ")
    locate (9, 14)
    txt ("@1~FPlayer Char RIGHT: ")
    locate (9, 18)
    txt ("@1~FOn player death:")
    locate (9, 15)
    txt ("@1~FPlayer Start Health: @4   ")
    locate (9, 16)
    txt ("@1~FPlayer MAX Health  : @4   ")
    locate (9, 19)
    txt ("@1~7( ) ~FChange board to: @4                         ") 
    locate (9, 20)
    txt ("@1~7( ) ~FMessage: @4                                 ")    
    locate (21, 22)
    txt ("@1~EPgDown = View Page #2")
    locate (9, 23)
    txt ("@1~AEnter = Change/Confirm     ~CESC = Exit/Cancel")
    worldinfo_screen = save_text_image ({2, 5}, {24, 56})
    -- World info: #2!!!
    colorfill (5, 3, 56, 23, 1)
    locate (7, 4)
    txt ("@1~FWorld Information: Page #2")                                
    locate (7, 5)
    txt ("@1~9--------")  
    locate (9, 7)
    txt ("@1~FStarting Board: @4                         ")     
    locate (9, 8)
    txt ("@1Bullet Damage (player): @4   ")
    locate (9, 9)
    txt ("@1Default Message Color:")
    locate (9, 10)
    txt ("~7[ ] ~FShow edges on one line messages")
    locate (9, 11)
    txt ("@1~Fx Player Bullet Color:")
    locate (9, 12)
    txt ("Player Bullet Char Up   :")
    locate (9, 13)
    txt ("Player Bullet Char Down :")
    locate (9, 14)
    txt ("Player Bullet Char Left :")
    locate (9, 15)
    txt ("Player Bullet Char Right:")                   
    locate (9, 16)
    txt ("~7")
    txt ({2})
    txt ("~F Robot Bullet Color :")
    locate (9, 17)
    txt ("Robot Bullet Char Up    :")
    locate (9, 18)
    txt ("Robot Bullet Char Down  :")
    locate (9, 19)                 
    txt ("Robot Bullet Char Left  :")
    locate (9, 20)
    txt ("Robot Bullet Char Right :")  
    locate (9, 22)
    txt ("~AEnter = Change   ~EPgUp = Page #1   ~CESC = Exit")                 
    worldinfo2_screen = save_text_image ({3, 5}, {23, 56})
    -- Save screen
    colorfill (15, 7, 46, 12, 1)
    locate (17, 8)
    txt ("@1~FSave World")
    locate (17, 9)
    txt ("@1~9------") 
    save_scrn = save_text_image ({7, 15}, {12, 46})    
    -- Load file screen
    colorfill (10, 3, 51, 23, 8)
    locate (12, 5)    
    txt ("@8~7-------") 
    locate (16, 21)
    txt ("~AEnter = Accept    ~CESC = Cancel~E")
    locate (12, 13)                                    
    txt ({175})
    txt ("                                    ")  
    txt ({174})    
    txt ("@1")
    for z = 8 to 19 do
        locate (17, z)
        txt ("                            ")    
    end for 
    loadfile_screen = save_text_image ({3, 10}, {23, 51})    
    -- Overlay toggle screen
    colorfill (10, 5, 51, 15, 1)
    locate (12, 7)
    txt ("@1~9-------")     
    locate (13, 9)
    txt ("~2")
    txt ({15})
    txt (" ~AOverlay")
    locate (15, 10)
    txt ("~F( ) Off")
    locate (15, 11)
    txt ("( ) Visible")
    locate (15, 12)
    txt ("( ) Transparent")
    locate (32, 9)
    txt ("~2")
    txt ({15})
    txt (" ~AOverlay2")
    locate (34, 10)
    txt ("~F( ) Off")
    locate (34, 11)
    txt ("( ) Visible")
    locate (34, 12)
    txt ("( ) Transparent")    
    locate (17, 14)
    txt ("~AEnter = Toggle    ~CESC = Exit~E")
    overlay_screen = save_text_image ({5, 10}, {15, 51})
    -- Edit message box scrn
    colorfill (10, 4, 51, 21, 1)
    locate (12, 5)
    txt ("@1~FEdit Message Box Parameters")                          
    locate (12, 6)
    txt ("~9-------")
    locate (14, 8)
    txt ("@1~FTop Left Corner X Position    : @4  ")
    locate (14, 9)
    txt ("@1~FTop Left Corner Y Position    : @4  ")
    locate (14, 10)
    txt ("@1~FBottom Right Corner X Position: @4  ")
    locate (14, 11)
    txt ("@1~FBottom Right Corner Y Position: @4  ")    
    locate (14, 13)
    txt ("@1~FBase Color   : ")
    locate (14, 14)
    txt ("@1~FOutline Color: ")
    locate (14, 15)
    txt ("@1~FTitle Color  : ")            
    locate (14, 17)
    txt ("@1~7[ ]~F Show message header")     
    locate (19, 19)
    txt ("@1~EP = Preview message box")
    locate (17, 20)
    txt ("@1~AEnter = Change    ~CESC = Exit")
    msgbox_screen = save_text_image ({4, 10}, {21, 51})
    -- Char edit screen
    colorfill (5, 2, 56, 22, 1)  
    locate (28, 3)
    txt ("~F@1Character Set Editor") 
    locate (28, 4)
    txt ("~9------") 
    locate (12, 19)
    txt ("~FCurrent #: ")
    locate (12, 20)
    txt ("~9----")
    locate (29, 7)
    txt ("~FSpace~7:   ~FToggle Pixel") 
    locate (29, 8)
    txt ("+/-~7:     ~FChange Char")  
    locate (29, 9)
    txt ("Enter~7:   ~FSelect Char")      
    locate (29, 10)
    txt ("Delete~7:  ~FClear Char")
    locate (29, 11)
    txt ("D~7:       ~FDefault Char")
    locate (29, 12)
    txt ("Alt+D~7:   ~FRestore ROM Set")
    locate (29, 13)
    txt ("N~7:       ~F")
    txt ({34})
    txt ("Negative")
    txt ({34})
    txt (" Effect")
    locate (29, 14)
    txt ("F~7:       ~F")
    txt ({34})
    txt ("Flip")
    txt ({34})
    txt (" Effect")
    locate (29, 15)
    txt ("M~7:       ~F")
    txt ({34})
    txt ("Mirror")
    txt ({34})
    txt ("Effect")
    locate (29, 16)
    txt ("Alt+")
    txt ({18})
    txt ({29})
    txt ("~7:  ~FShift Char") 
    locate (29, 17)
    txt ("~7{~FAlt+~7}~FC~7: ~FCopy Char")
    locate (29, 18)
    txt ("~7{~FAlt+~7}~FP~7: ~FPaste Char")   
    locate (29, 19)
    txt ("Tab~7: ~FEnter/exit Draw Mode") 
    locate (29, 21)
    txt ("~CESC~7: ~FExit!")    
    char_edit_screen = save_text_image ({2, 5}, {22, 56})
    -- Palette editing screen
    colorfill (5, 5, 56, 19, 1)
    locate (7, 6)
    txt ("@1~FPalette Editor                        ~CESC = Exit")
    locate (7, 7)
    txt ("@1~9--------")        
    locate (7, 12)
    txt ("@1~FColor ~7#__     ~FRED: __~7/~F63  GRN: __~7/~F63  BLU: __~7/~F63")
    locate (7, 14)
    txt ("@1~FR,G,B: Increase color  Alt+R,G,B: Decrease color")  
    locate (7, 15)
    txt ("@1~7{~FAlt+~7}~FD: Dflt clr~7{~Fpal~7} ~F0,W: Black/white color")
    locate (7, 16)
    txt ("@1~FAlt+C: Copy color      Alt+P: Paste color")
    palette_edit_screen = save_text_image ({5, 5}, {19, 56})   
    ----------------------------
    -- ** End of screen-grabbing
    colorfill (1, 1, 60, 25, 0) 
    -- THIS LINE LOADS THE MOD PLAYER!
    -- (off ... currently only loads when needed, ie. board info edit scrn)
    --junk = init_modwave (STEREO, 44100, 20)        
    --volume_up ()
    -- Add error testing later ... ;)
    set_display_page (0)    
    -- Next lines grab default palette and char set
    -- (Note: Change to load from file later! ^_^)
    default_palette = get_all_palette ()          
end procedure

----------------------------------------------------------------------------
-- Adds a new, empty board
-- types: 0=space 1=block 2=robot 3=flr 4=overlay 5=overlay2 9=player
procedure add_board () 
    sequence back 
    sequence newtitle           
    integer tx, ty, key
    newtitle = ""              
    key = -1
    back = save_text_image ({9, 5}, {17, 56})
    -- Get name for board
    display_text_image ({9, 5}, add_board_screen)
    locate (7, 13)
    txtf ("@1~EPlease enter the name for new board #%d", {worldinfo[4]+1})
    tx = 7
    ty = 15
    txt ("@4~F")
    locate (tx, ty)
    cursor (BLOCK_CURSOR)
    while 1 do         
        key = get_key ()
        if key = 8 then  -- Backspace        
            if compare (newtitle, "") != 0 then
                newtitle = newtitle [1..length(newtitle) - 1]
                tx = tx - 1           
                locate (tx, ty)
                txt (" ")
                locate (tx, ty)
            end if     
        elsif key = 13 or key = 27 then  -- Enter (or ESC)
            exit                                                     
        elsif key != -1 and key != '@' and key != '~' and key != 254 and
            length (newtitle) <= 24 then  -- Text     
            newtitle = append (newtitle, key)
            txt ({key})
            tx = tx + 1
            locate (tx, ty)
        end if
    end while  
    if key != 27 then -- Unless user cancelled, add new board          
    -- Incs 'total boards'
    worldinfo[4] = worldinfo[4] + 1
    -- If just Enter pressed, reset title
    if compare (newtitle, "") = 0 then
        newtitle = "Unnamed"  
    end if                                                                  
    -- Add new board to sequences
    main = main & repeat (repeat (repeat ({0, ' ', 0, 7, 0}, 25), 60), 1)   
    -- format for rest: {color, bkcolor, char}
    flr = flr & repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1)
    overlay = overlay & repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1)
    overlay2 = overlay2 & repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1) 
    boardinfo = boardinfo & {{"temp", 255, 0, 0, 0, 0, "None",
                              0, 0, 0}} 
    boardinfo [worldinfo[4]][1] = newtitle 
    -- Sets initial player position
    main [worldinfo[4]] [30] [12] = {9, 2, 0, worldinfo[9], worldinfo[10]}
    -- Move user to board (s)he just created
    if compare (boardinfo[current_board][7], "None") != 0 then
        unload_mod ()    
    end if
    current_board = worldinfo[4]
    if compare (boardinfo[current_board][7], "None") != 0 then
        junk = load_mod (boardinfo[current_board][7])    
    end if
    current_layer = 0
    end if              
    display_text_image ({9, 5}, back)
end procedure

----------------------------------------------------------------------------
-- Clears everything; makes one, empty board
-- types: 0=space 1=block 2=robot 3=flr 4=overlay 5=overlay2 9=player
procedure clear_world ()             
    sequence getdate
    -- 'main' format: {type, char, ref#, color, bkcolor}   
    -- when refrencing 'main':--> main [level] [x] [y] [vars]
    current_board = 1
    main = repeat (repeat (repeat ({0, ' ', 0, 7, 0}, 25), 60), 1)   
    -- format for rest: {color, bkcolor, char}
    flr = repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1)
    overlay = repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1)
    overlay2 = repeat (repeat (repeat ({7, 0, ' '}, 25), 60), 1) 
    roboparam = {}
    robocode = {}                           
    curr_palette = default_palette
    curr_charset = default_charset
    -- Max len of robot name (1st line of prog code) is *14*
    getdate = date ()
    -- \_If only it were that easy in real life. ;)  
    worldinfo = {"Untitled", "Anonymous", "Not Saved", 1,
                 2, 2, 2, 2, 15, 1, 
                 100, 100, 1, 
                 "G a m e   o v e r",
                 getdate[1], getdate[2], getdate[3],
                 10, 5, 51, 20,
                 31, 16, 30, 1,  
                 7, 248, 248, 248, 248,
                 7, 248, 248, 248, 248,
                 1, 10, 15, 1,
                 1, 1}
    -- worldinfo format:
    --1  { worldtitle, author, filename, totalboards,
    --5   playerchar_up, pc_down, pc_left, pc_right, pcolor, pbkcolor,
    --11  starting health, maxhealth, deathdotype(0=brd,1=msg),
    --14  deathboardname/message,
    --15  year, month, day,      
    --18  msgboxtopX, mbtopY, mbbotX, mbbotY,    
    --22  mbbasecolor, mboutlinecolor, mbtitlecolor, header(0=no,1=yes),
    --26  p_bullet_color, p_bullet_up, pb_down, pb_left, pb_right, 
    --31  r_bullet_color, r_bullet_up, rb_down, rb_left, rb_right,
    --36  start_board, bulletdamage, dfltmesgcolor, mesgedge(0=no,1=yes),
    --40  #ofcharsets, #ofpalettes }
    boardinfo = repeat ({"Title Screen", 255, 0, 0, 0, 0, "None",
                         0, 0, 0}, 1)
    -- Sets up board ... uh, stuff     
    -- format: {name, shots, exitup, down, left, right, modname,
    -- 8  #overlays, overlay_on(0=off,1=on,2=trans.), overlay2_on}        
    -- Sets initial player position
    main [1] [30] [12] = {9, 2, 0, worldinfo[9], worldinfo[10]}
end procedure

----------------------------------------------------------------------------
-- Clears a single board
procedure clear_board ()
    integer yesorno
    yesorno = ask ("Clear current board: Are you sure?")
    if yesorno = 1 then
        -- Clear board 
        main [current_board] = repeat (repeat ({0, ' ', 0, 7, 0}, 25), 60)   
        -- format for rest: {color, bkcolor, char}
        flr [current_board] = repeat (repeat ({7, 0, ' '}, 25), 60)
        overlay [current_board] = repeat (repeat ({7, 0, ' '}, 25), 60)
        overlay2 [current_board] = repeat (repeat ({7, 0, ' '}, 25), 60) 
        boardinfo [current_board] = {"Title Screen", 255, 0, 0, 0, 0,
                                     "None", 0, 0, 0}
        -- Set initial player position
        main [worldinfo[4]] [30] [12] = {9, worldinfo[5], 0, worldinfo[9],
              worldinfo[10]}
    end if
end procedure

----------------------------------------------------------------------------
-- Show current obj
procedure show_current ()
    cursor (NO_CURSOR)
    locate (62, 17)
    txt ("@1~F               ")
    locate (62, 17)
    if current_type = 0 then
        txt ("~FSpace ")
    elsif current_type = 1 then
        txt ("~FBlock ")
    elsif current_type = 2 then
        txtf ("~F%s ", roboparam [current_ref][1])
    elsif current_type = 3 then
        txt ("~FFloor ")
    elsif current_type = 4 then
        txt ("~FOverlay ")
    elsif current_type = 5 then
        txt ("~FOverlay2 ")      
    end if         
    txt ("~7[")
    if current_type = 0 then
        txt ("@0~7 ")     
    else
        set_color (current_color)
        set_bkcolor (current_bkcolor)
        txt ({current_char})
    end if
    txt ("@1~7]")      
    -- Display the current layer
    locate (63, 23)
    if current_layer = -1 then
        txt ("~FFLOOR LAYER (-1) ")
    elsif current_layer = 0 then
        txt ("~FBASE LAYER   (0) ")
    elsif current_layer = 1 then
        txt ("~FOVERLAY #1   (1) ")
    else
        txt ("~FOVERLAY #2   (2) ")
    end if
    cursor (BLOCK_CURSOR)
end procedure

----------------------------------------------------------------------------
-- Prints one char using same system as printing entire board
procedure do_right_char (integer p, integer z)
    integer pic_fc, pic_bc, pic_chr, c_b
    --p = cx
    --z = cy                                    
    c_b = current_board
    if current_layer = 2 then  -- Overlay2
        if overlay2[c_b][p][z][3] != ' ' and overlay2[c_b][p][z][2] = 0 then
            pic_fc = overlay2[c_b][p][z][1]
            pic_chr = overlay2[c_b][p][z][3]
            if overlay[c_b][p][z][2] != 0 then
                pic_bc = overlay[c_b][p][z][2]
            elsif main[c_b][p][z][5] != 0 then
                pic_bc = main[c_b][p][z][5]
            else
                pic_bc = flr[c_b][p][z][2]
            end if
        elsif overlay2[c_b][p][z][3] != ' ' then
            pic_fc = overlay2[c_b][p][z][1]
            pic_bc = overlay2[c_b][p][z][2]  
            pic_chr = overlay2[c_b][p][z][3]               
        elsif overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
            pic_fc = overlay[c_b][p][z][1]
            pic_chr = overlay[c_b][p][z][3]
            if main[c_b][p][z][5] != 0 then
                pic_bc = main[c_b][p][z][5]  
            else
                pic_bc = flr[c_b][p][z][2]  
            end if            
        elsif overlay[c_b][p][z][3] != ' ' then
            pic_fc = overlay[c_b][p][z][1]
            pic_bc = overlay[c_b][p][z][2]  
            pic_chr = overlay[c_b][p][z][3] 
        elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_fc = main[c_b][p][z][4]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_fc = main[c_b][p][z][4]
            pic_bc = main[c_b][p][z][5]
            pic_chr = main[c_b][p][z][2]
        else
            pic_fc = flr[c_b][p][z][1]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = flr[c_b][p][z][3]                            
        end if        
    elsif current_layer = 1 then  -- Overlay
        if overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
            pic_fc = overlay[c_b][p][z][1]
            pic_chr = overlay[c_b][p][z][3]
            if main[c_b][p][z][5] != 0 then
                pic_bc = main[c_b][p][z][5]  
            else
                pic_bc = flr[c_b][p][z][2]  
            end if            
        elsif overlay[c_b][p][z][3] != ' ' then
            pic_fc = overlay[c_b][p][z][1]
            pic_bc = overlay[c_b][p][z][2]  
            pic_chr = overlay[c_b][p][z][3] 
        elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_fc = main[c_b][p][z][4]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_fc = main[c_b][p][z][4]
            pic_bc = main[c_b][p][z][5]
            pic_chr = main[c_b][p][z][2]
        else
            pic_fc = flr[c_b][p][z][1]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = flr[c_b][p][z][3]                            
        end if        
    elsif current_layer = 0 then  -- Main
        if main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_fc = main[c_b][p][z][4]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_fc = main[c_b][p][z][4]
            pic_bc = main[c_b][p][z][5]
            pic_chr = main[c_b][p][z][2]
        else
            pic_fc = flr[c_b][p][z][1]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = flr[c_b][p][z][3]                            
        end if          
    elsif current_layer = -1 then  -- Floor
        pic_fc = flr[c_b][p][z][1]
        pic_bc = flr[c_b][p][z][2]
        pic_chr = flr[c_b][p][z][3]        
    end if                         
    locate (p, z)
    set_color (pic_fc)
    set_bkcolor (pic_bc)
    txt ({pic_chr})
end procedure

----------------------------------------------------------------------------
-- Does the 'right char' cept with given color (for block stuff ...)
procedure do_right_char_color (integer pic_fc, integer pic_bc, integer p, integer z)
    integer pic_chr, c_b
    --p = cx
    --z = cy                                    
    c_b = current_board
    if current_layer = 2 then  -- Overlay2
        if overlay2[c_b][p][z][3] != ' ' and overlay2[c_b][p][z][2] = 0 then
            pic_chr = overlay2[c_b][p][z][3]
        elsif overlay2[c_b][p][z][3] != ' ' then
            pic_chr = overlay2[c_b][p][z][3]               
        elsif overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
            pic_chr = overlay[c_b][p][z][3]
        elsif overlay[c_b][p][z][3] != ' ' then
            pic_chr = overlay[c_b][p][z][3] 
        elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_chr = main[c_b][p][z][2]
        else
            pic_chr = flr[c_b][p][z][3]                            
        end if        
    elsif current_layer = 1 then  -- Overlay
        if overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
            pic_chr = overlay[c_b][p][z][3]
        elsif overlay[c_b][p][z][3] != ' ' then
            pic_chr = overlay[c_b][p][z][3] 
        elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_chr = main[c_b][p][z][2]
        else
            pic_chr = flr[c_b][p][z][3]                            
        end if        
    elsif current_layer = 0 then  -- Main
        if main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
            pic_chr = main[c_b][p][z][2]
        elsif main[c_b][p][z][2] != ' ' then
            pic_chr = main[c_b][p][z][2]
        else
            pic_chr = flr[c_b][p][z][3]                            
        end if          
    elsif current_layer = -1 then  -- Floor
        pic_chr = flr[c_b][p][z][3]        
    end if                         
    locate (p, z)
    set_color (pic_fc)
    set_bkcolor (pic_bc)
    txt ({pic_chr})
end procedure

----------------------------------------------------------------------------
-- Blue info sidebar
procedure draw_sidebar ()     
    cursor (NO_CURSOR)
    display_text_image ({1, 61}, infobar)
    locate (62, 4)
    txtf ("@1~4(~C%d~4, ~C%d~4)  ", {cx, cy})   
    locate (62, 12)
    txtf ("@1~F%s", {worldinfo[1]}) 
    locate (62, 13)
    txtf ("@1~E%s", {worldinfo[2]}) 
    locate (62, 14)
    txtf ("@1~7%s", {worldinfo[3]})
    locate (62, 15)
    txtf ("@1~ABoard: %d~2 / ~A%d", {current_board, worldinfo[4]})
    locate (62, 16)
    txt ("@1~ECurrent Object:")
    show_current ()
    locate (62, 20)
    txt ("@1~9-----")
    if drawing = 1 then
        locate (62, 19)
        txt ("@1~E Drawing ON ")
    else
        locate (62, 19)
        txt ("@1~8 Drawing OFF")
    end if
    locate (63, 23)
    if current_layer = -1 then
        txt ("~FFLOOR LAYER (-1) ")
    elsif current_layer = 0 then
        txt ("~FBASE LAYER   (0) ")
    elsif current_layer = 1 then
        txt ("~FOVERLAY #1   (1) ")
    else
        txt ("~FOVERLAY #2   (2) ")
    end if
    cursor (BLOCK_CURSOR)
end procedure    

----------------------------------------------------------------------------
-- Shows whole board (excluding spaces) from array(s)
-- (This is the new, twice as long, 'fast' version ^_^)
procedure draw_all_board ()     
    sequence bpic, oneline
    integer pic_fc, pic_bc, pic_chr, colorval, c_b
    bpic = {}                                     
    c_b = current_board  -- Just to keep the lines to around 80 cols :)
    cursor (NO_CURSOR)
    for z = 1 to 25 do    
        oneline = {}
        for p = 1 to 60 do
            -- Overlay2
            if overlay2[c_b][p][z][3] != ' ' and overlay2[c_b][p][z][2] = 0 then
                pic_fc = overlay2[c_b][p][z][1]
                pic_chr = overlay2[c_b][p][z][3]
                if overlay[c_b][p][z][2] != 0 then
                    pic_bc = overlay[c_b][p][z][2]
                elsif main[c_b][p][z][5] != 0 then
                    pic_bc = main[c_b][p][z][5]
                else
                    pic_bc = flr[c_b][p][z][2]
                end if
            elsif overlay2[c_b][p][z][3] != ' ' then
                pic_fc = overlay2[c_b][p][z][1]
                pic_bc = overlay2[c_b][p][z][2]  
                pic_chr = overlay2[c_b][p][z][3]               
            -- Overlay
            elsif overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
                pic_fc = overlay[c_b][p][z][1]
                pic_chr = overlay[c_b][p][z][3]
                if main[c_b][p][z][5] != 0 then
                    pic_bc = main[c_b][p][z][5]  
                else
                    pic_bc = flr[c_b][p][z][2]  
                end if            
            elsif overlay[c_b][p][z][3] != ' ' then
                pic_fc = overlay[c_b][p][z][1]
                pic_bc = overlay[c_b][p][z][2]  
                pic_chr = overlay[c_b][p][z][3] 
            -- Main
            elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
                pic_fc = main[c_b][p][z][4]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = main[c_b][p][z][2]
            elsif main[c_b][p][z][2] != ' ' then
                pic_fc = main[c_b][p][z][4]
                pic_bc = main[c_b][p][z][5]
                pic_chr = main[c_b][p][z][2]
            -- Floor
            else
                pic_fc = flr[c_b][p][z][1]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = flr[c_b][p][z][3]                            
            end if  
            -- Get 'mixed' color
            colorval = pic_fc + (pic_bc * 16)
            oneline = oneline & pic_chr
            oneline = oneline & colorval   
        end for                         
        bpic = append (bpic, oneline)
    end for                          
    -- Doooooooo it! (nmiaow!!)
    display_text_image ({1, 1}, bpic)
end procedure

----------------------------------------------------------------------------
-- Draws only the overlay (and down) levels! YAY!
procedure draw_overlay_only ()     
    sequence bpic, oneline
    integer pic_fc, pic_bc, pic_chr, colorval, c_b
    bpic = {}                                     
    c_b = current_board  -- Just to keep the lines to around 80 cols :)
    cursor (NO_CURSOR)
    for z = 1 to 25 do    
        oneline = {}
        for p = 1 to 60 do
            -- Overlay
            if overlay[c_b][p][z][3] != ' ' and overlay[c_b][p][z][2] = 0 then
                pic_fc = overlay[c_b][p][z][1]
                pic_chr = overlay[c_b][p][z][3]
                if main[c_b][p][z][5] != 0 then
                    pic_bc = main[c_b][p][z][5]  
                else
                    pic_bc = flr[c_b][p][z][2]  
                end if            
            elsif overlay[c_b][p][z][3] != ' ' then
                pic_fc = overlay[c_b][p][z][1]
                pic_bc = overlay[c_b][p][z][2]  
                pic_chr = overlay[c_b][p][z][3] 
            -- Main
            elsif main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
                pic_fc = main[c_b][p][z][4]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = main[c_b][p][z][2]
            elsif main[c_b][p][z][2] != ' ' then
                pic_fc = main[c_b][p][z][4]
                pic_bc = main[c_b][p][z][5]
                pic_chr = main[c_b][p][z][2]
            -- Floor
            else
                pic_fc = flr[c_b][p][z][1]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = flr[c_b][p][z][3]                            
            end if  
            -- Get 'mixed' color
            colorval = pic_fc + (pic_bc * 16)
            oneline = oneline & pic_chr
            oneline = oneline & colorval   
        end for                         
        bpic = append (bpic, oneline)
    end for                          
    -- Doooooooo it! (nmiaow!!)
    display_text_image ({1, 1}, bpic)
end procedure

----------------------------------------------------------------------------
-- Draws only the main (and floor) levels! YAY!
procedure draw_main_only ()
    sequence bpic, oneline
    integer pic_fc, pic_bc, pic_chr, colorval, c_b
    bpic = {}                                     
    c_b = current_board  -- Just to keep the lines to around 80 cols :)
    cursor (NO_CURSOR)
    for z = 1 to 25 do    
        oneline = {}
        for p = 1 to 60 do
            -- Main
            if main[c_b][p][z][2] != ' ' and main[c_b][p][z][5] = 0 then
                pic_fc = main[c_b][p][z][4]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = main[c_b][p][z][2]
            elsif main[c_b][p][z][2] != ' ' then
                pic_fc = main[c_b][p][z][4]
                pic_bc = main[c_b][p][z][5]
                pic_chr = main[c_b][p][z][2]
            -- Floor
            else
                pic_fc = flr[c_b][p][z][1]
                pic_bc = flr[c_b][p][z][2]
                pic_chr = flr[c_b][p][z][3]                            
            end if  
            -- Get 'mixed' color
            colorval = pic_fc + (pic_bc * 16)
            oneline = oneline & pic_chr
            oneline = oneline & colorval   
        end for                         
        bpic = append (bpic, oneline)
    end for                          
    -- Doooooooo it! (nmiaow!!)
    display_text_image ({1, 1}, bpic)
end procedure
                      
----------------------------------------------------------------------------
-- Draws only the floor level! YAY!
procedure draw_floor_only ()     
    sequence bpic, oneline
    integer pic_fc, pic_bc, pic_chr, colorval, c_b
    bpic = {}                                     
    c_b = current_board  -- Just to keep the lines to 80 cols :)
    cursor (NO_CURSOR)         
    for z = 1 to 25 do
        oneline = {}
        for p = 1 to 60 do           
            -- 'floor' layer (duh!)
            pic_fc = flr[c_b][p][z][1]
            pic_bc = flr[c_b][p][z][2]
            pic_chr = flr[c_b][p][z][3]                            
            colorval = pic_fc + (pic_bc * 16)
            oneline = oneline & pic_chr
            oneline = oneline & colorval   
        end for
        bpic = append (bpic, oneline)
    end for                              
    -- Doooooooo it! (nmiaow!!)
    display_text_image ({1, 1}, bpic)
end procedure

----------------------------------------------------------------------------
-- Allows user to easily choose their color (hopefully ^_^)
function choose_color (sequence colors)
    object key
    integer tx, ty
    sequence back, newcolor
    newcolor = {0, 0}
    newcolor [1] = colors[1]
    newcolor [2] = colors[2]
    back = save_text_image ({3, 13}, {23, 48})
    key = -1
    tx = 16 + newcolor [1]
    ty = 7 + newcolor [2]
    cursor (NO_CURSOR)
    display_text_image ({3, 13}, color_screen)
    set_color (tx - 16)
    set_bkcolor (ty - 7)
    locate (34, 16)
    txt ("Current Color")
    locate (34, 17)
    txt ({1})
    txt (" - ۲ ")      
    locate (tx, ty) 
    cursor (BLOCK_CURSOR)
    -- Allow player to move cursor around in box ... yeah.
    locate (tx, ty)
    while 1 do
        if key != -1 then
        if key = k_up then  -- Up
            if ty = 7 then 
                ty = 22
            else
                ty = ty - 1                            
            end if
        elsif key = k_down then -- Down
            if ty = 22 then 
                ty = 7
            else
                ty = ty + 1                            
            end if
        elsif key = k_left then  -- Left
            if tx = 16 then 
                tx = 31
            else
                tx = tx - 1                            
            end if
        elsif key = k_right then  -- Right
            if tx = 31 then
                tx = 16
            else
                tx = tx + 1
            end if 
        elsif key = 27 or key = 13 or key = 'C' or key = 'c' then
            exit           
        end if   
        cursor (NO_CURSOR)
        set_color (tx - 16)
        set_bkcolor (ty - 7)
        locate (34, 16)
        txt ("Current Color")
        locate (34, 17)
        txt ({1})
        txt (" - ۲ ")      
        locate (tx, ty) 
        cursor (BLOCK_CURSOR)
        end if
        key = get_key ()
    end while    
    if key = 13 then
        newcolor [1] = tx - 16
        newcolor [2] = ty - 7         
    else
        newcolor = {-1, -1}
    end if
    display_text_image ({3, 13}, back)
    return newcolor
end function             

----------------------------------------------------------------------------
-- Choose new char ...
function choose_char (integer startchar, integer fc, integer bc)
    object key    
    integer tx, ty, flip, newchar
    sequence back
    back = save_text_image ({6, 6}, {20, 55})
    flip = 1
    key = -1
    display_text_image ({6, 6}, char_screen)
    -- Set new cursor pos.
    tx = charmap2 [startchar+1] [1]
    ty = charmap2 [startchar+1] [2]
    cursor (NO_CURSOR)
    locate (8, 19)
    txt ("@8~EPreview: ~7[")
    set_color (fc)
    set_bkcolor (bc)
    txt ({charmap [tx] [ty]})  
    txt ("@8~7]")      
    locate (tx + 7, ty + 9) 
    cursor (BLOCK_CURSOR)
    -- Allow movement! Fwee!
    while 1 do
        if key != -1 then
        if key = k_up then  -- Up
            if ty = 1 then 
                ty = 8
            else
                ty = ty - 1                            
            end if
        elsif key = k_down then -- Down
            if ty = 8 then 
                ty = 1
            else
                ty = ty + 1                            
            end if
        elsif key = k_left then  -- Left
            if tx = 1 then 
                tx = 32
            else
                tx = tx - 1                            
            end if
        elsif key = k_right then  -- Right
            if tx = 32 then
                tx = 1
            else
                tx = tx + 1
            end if 
        elsif key = 27 then
            exit           
        elsif key = 13 and (tx != 1 or ty != 1) then
            exit
        end if                 
        cursor (NO_CURSOR)
        locate (8, 19)
        txt ("@8~EPreview: ~7[")
        set_color (fc)
        set_bkcolor (bc)
        txt ({charmap [tx] [ty]})  
        txt ("@8~7]")      
        locate (tx + 7, ty + 9)
        cursor (BLOCK_CURSOR) 
        end if
        key = get_key ()
    end while
    -- Set new char (if Enter)
    if key = 13 then
        newchar = charmap [tx] [ty]
    else
        newchar = -1
    end if
    display_text_image ({6, 6}, back)             
    return newchar
end function             

----------------------------------------------------------------------------
-- The 'spacebar' put to place current obj
procedure place_current ()
    locate (cx, cy)                      
    -- Write char to appropriate 'layer'
    if current_layer = -1 then  
        flr [current_board] [cx] [cy] [3] = current_char
    elsif current_layer = 0 then        
        main [current_board] [cx] [cy] [1] = current_type
        main [current_board] [cx] [cy] [2] = current_char
        main [current_board] [cx] [cy] [3] = current_ref
    elsif current_layer = 1 then
        overlay [current_board] [cx] [cy] [3] = current_char
    else
        overlay2 [current_board] [cx] [cy] [3] = current_char            
    end if
    -- Write colors to appropriate 'layer'
    if current_type = 0 then
        main [current_board] [cx] [cy] [4] = 7    
        main [current_board] [cx] [cy] [5] = 0 
    else
        if current_layer = -1 then  
            flr [current_board] [cx] [cy] [1] = current_color
            flr [current_board] [cx] [cy] [2] = current_bkcolor
        elsif current_layer = 0 then           
            main [current_board] [cx] [cy] [4] = current_color    
            main [current_board] [cx] [cy] [5] = current_bkcolor
        elsif current_layer = 1 then
            overlay [current_board] [cx] [cy] [1] = current_color
            overlay [current_board] [cx] [cy] [2] = current_bkcolor            
        else
            overlay2 [current_board] [cx] [cy] [1] = current_color
            overlay2 [current_board] [cx] [cy] [2] = current_bkcolor            
        end if 
    end if
    -- Display the char! Yeehaw dawgies.
    do_right_char (cx, cy)
end procedure

----------------------------------------------------------------------------
-- 'grab' obj using ins
procedure grab_obj ()
    sequence temp
    if current_layer = -1 then
        current_type = 3
        current_char = flr [current_board] [cx] [cy] [3] 
        current_ref = 0             
        current_color = flr [current_board] [cx] [cy] [1]     
        current_bkcolor = flr [current_board] [cx] [cy] [2]
        --                      /~That prevents user from 'grabbin' player  
    elsif current_layer = 0 and main[current_board][cx][cy][1] != 9 then
        current_type = main [current_board] [cx] [cy] [1]
        current_char = main [current_board] [cx] [cy] [2] 
        current_ref = main [current_board] [cx] [cy] [3]             
        current_color = main [current_board] [cx] [cy] [4]     
        current_bkcolor = main [current_board] [cx] [cy] [5]
    elsif current_layer = 1 then
        current_type = 4
        current_char = overlay [current_board] [cx] [cy] [3] 
        current_ref = 0             
        current_color = overlay [current_board] [cx] [cy] [1]     
        current_bkcolor = overlay [current_board] [cx] [cy] [2]          
    elsif current_layer = 2 then        
        current_type = 5
        current_char = overlay2 [current_board] [cx] [cy] [3] 
        current_ref = 0             
        current_color = overlay2 [current_board] [cx] [cy] [1]     
        current_bkcolor = overlay2 [current_board] [cx] [cy] [2]          
    end if
    show_current ()        
end procedure

----------------------------------------------------------------------------
-- Choose type (in 'main' only), ie 0/Space, 1/Block, 2/Robot (3=player)
procedure choose_type () 
    object key                                               
    sequence back
    sequence mn
    integer pointer
    pointer = 1  
    key = 1
    mn = {"    Space                 ", "    Block                 ",
          "    Robot                 "}
    back = save_text_image ({8, 16}, {15, 45})
    cursor (NO_CURSOR)
    colorfill (16, 8, 45, 15, 1)
    locate (18, 9)
    txt ("@1~FSelect type")
    locate (18, 10)
    txt ("~9------")
    while 1 do
        if key != -1 then
        if key = k_up then  -- Up
            if pointer = 1 then
                pointer = length (mn)
            else
                pointer = pointer - 1    
            end if                   
        elsif key = k_down then  -- Down
            if pointer = length (mn) then
                pointer = 1
            else
                pointer = pointer + 1    
            end if
        end if
        txt ("@1~E")
        for z = 1 to length (mn) do
            locate (18, 11 + z)
            txt (mn [z])    
        end for
        locate (18, 11 + pointer)
        txt ("@9~E")
        txt (mn [pointer])
        locate (19, 11 + pointer)
        txt ("@9~C")
        txt ({175})
        end if                       
        if key = 27 or key = 13 then
            exit    
        end if 
        key = -1
        key = get_key ()
    end while         
    if key = 13 then
        current_type = pointer - 1
        if current_type = 0 then
            current_color = 7
            current_bkcolor = 0
            current_char = ' '    
        end if
        draw_sidebar ()    
    end if             
    display_text_image ({8, 16}, back)
    cursor (BLOCK_CURSOR)
end procedure

----------------------------------------------------------------------------
-- Used for drawing ... (duh)
procedure check_drawing ()   
    if drawing = 1 then
        -- Makes sure user is on 'main' and not overwriting player
        if current_layer = 0 then
            if main[current_board][cx][cy][1] != 9 then
                place_current ()
            end if
        else
            place_current ()
        end if
    end if
end procedure           

----------------------------------------------------------------------------
-- Text entry mode ... it's amazingly complicated! ;)
procedure type_text ()
    object key   
    integer originalx
    originalx = cx
    key = -1   
    cursor (NO_CURSOR)
    locate (63, 22)
    txt ("@1~FType Text Mode  ")
    locate (63, 23)
    txt ("@1~AEnter: New line ")
    locate (63, 24)
    txt ("@1~CESC: Exit mode  ")
    locate (cx, cy)
    cursor (UNDERLINE_CURSOR)
    while 1 do
        if key != -1 then
            if key = 319 or key = 27 then
                exit
            elsif key = 13 then  -- Enter
                cx = originalx
                cy = cy + 1 
            elsif key = 8 then  -- Backspace
                if cx != 1 then
                    cx = cx - 1     
                    -- Clears one space of current layer
                    if current_layer = -1 then  -- Floor
                        flr[current_board][cx][cy][1] = 7
                        flr[current_board][cx][cy][2] = 0
                        flr[current_board][cx][cy][3] = ' '
                    elsif current_layer = 0 then  -- Main
                        main[current_board][cx][cy][1] = 0
                        main[current_board][cx][cy][2] = ' '
                        main[current_board][cx][cy][3] = 0
                        main[current_board][cx][cy][4] = 7
                        main[current_board][cx][cy][5] = 0
                    elsif current_layer = 1 then  -- Overlay
                        overlay[current_board][cx][cy][1] = 7
                        overlay[current_board][cx][cy][2] = 0
                        overlay[current_board][cx][cy][3] = ' '
                    elsif current_layer = 2 then  -- Overlay2
                        overlay2[current_board][cx][cy][1] = 7
                        overlay2[current_board][cx][cy][2] = 0
                        overlay2[current_board][cx][cy][3] = ' '
                    end if
                    --locate (cx, cy)
                    do_right_char (cx, cy)
                end if           
            elsif key = ' ' then
                if cx < 60 then
                    cx = cx + 1                            
                end if           
            -- The next few 'if's allow cursor movement
            elsif key = k_up then  -- Up
                if cy > 1 then
                    cy = cy - 1    
                end if         
            elsif key = k_down then  -- Down
                if cy < 25 then
                    cy = cy + 1    
                end if         
            elsif key = k_left then  -- Left
                if cx > 1 then
                    cx = cx - 1
                    originalx = cx    
                end if            
            elsif key = k_right then  -- Right
                if cx < 60 then
                    cx = cx + 1
                    originalx = cx
                end if   
            -- All the 'and's make sure user didn't try to alt-move ;)             
            elsif key != 408 and  -- No alt-up
                key != 416 and  -- Or alt-down
                key != 411 and  -- Or alt-left
                key != 413 then  -- Or alt-right, even!    
                -- If a normal text char is entered
                set_color (current_color)
                if current_bkcolor = 0 then  
                    set_bkcolor (flr [current_board] [cx] [cy] [2])
                else            
                    set_bkcolor (current_bkcolor) 
                end if            
                txt ({key})
                -- This 'if' enables text-entry on any layer, not just 'main'
                if current_layer = 0 then
                    main [current_board] [cx] [cy] [1] = 1
                    main [current_board] [cx] [cy] [2] = key
                    main [current_board] [cx] [cy] [3] = 0
                    main [current_board] [cx] [cy] [4] = current_color
                    main [current_board] [cx] [cy] [5] = current_bkcolor                   
                elsif current_layer = -1 then
                    flr [current_board] [cx] [cy] [1] = current_color
                    flr [current_board] [cx] [cy] [2] = current_bkcolor
                    flr [current_board] [cx] [cy] [3] = key
                elsif current_layer = 1 then
                    overlay [current_board] [cx] [cy] [1] = current_color
                    overlay [current_board] [cx] [cy] [2] = current_bkcolor
                    overlay [current_board] [cx] [cy] [3] = key
                elsif current_layer = 2 then                    
                    overlay2 [current_board] [cx] [cy] [1] = current_color
                    overlay2 [current_board] [cx] [cy] [2] = current_bkcolor
                    overlay2 [current_board] [cx] [cy] [3] = key  
                end if
                if cx < 60 then
                    cx = cx + 1                            
                end if
            end if          
            cursor (NO_CURSOR)
            locate (62, 4)
            txtf ("@1~4(~C%d~4, ~C%d~4)  ", {cx, cy}) 
            locate (cx, cy)
            cursor (UNDERLINE_CURSOR)  
        end if                 
        key = -1
        key = get_key ()             
    end while            
    cursor (NO_CURSOR)
    locate (63, 22)
    txt ("@1~F              ")
    show_current ()
    locate (63, 24)
    txt ("              ")
    cursor (BLOCK_CURSOR)
end procedure

----------------------------------------------------------------------------
-- Draws a different # of layers depending on which layer user is on
procedure draw_appropriate ()
    if current_layer = -1 then
        draw_floor_only ()
    elsif current_layer = 0 then
        draw_main_only ()  
    elsif current_layer = 1 then
        draw_overlay_only ()
    elsif current_layer = 2 then
        draw_all_board ()
    end if
end procedure

----------------------------------------------------------------------------
-- Sets up 'current's when changing layers
procedure reset_current_obj ()
    if current_layer = -1 then
        current_type = 3  -- Floor
    elsif current_layer = 0 then
        current_type = 1  -- Block
    elsif current_layer = 1 then
        current_type = 4  -- Overlay
    elsif current_layer = 2 then
        current_type = 5  -- Overlay2
    end if
end procedure

----------------------------------------------------------------------------
-- Shows cursor & two dots for toggle_overlays
procedure overlay_show_pointer (integer pos)
    display_text_image ({5, 10}, overlay_screen)
    locate (12, 6)
    txtf ("@1~FOverlays for board #%d", {current_board})     
    -- Show appropriate dots
    txt ("@1~E")
    if boardinfo[current_board][9] = 0 then  -- Overlay
        locate (16, 10)
    elsif boardinfo[current_board][9] = 1 then
        locate (16, 11)
    else
        locate (16, 12)
    end if
    txt ({7})    
    if boardinfo[current_board][10] = 0 then  -- Overlay2
        locate (35, 10)
    elsif boardinfo[current_board][10] = 1 then
        locate (35, 11)
    else
        locate (35, 12)
    end if
    txt ({7})    
    -- Show cursor
    if pos = 1 then  
        locate (13, 10)   
    elsif pos = 2 then
        locate (13, 11)
    elsif pos = 3 then
        locate (13, 12)
    elsif pos = 4 then
        locate (32, 10)
    elsif pos = 5 then
        locate (32, 11)
    elsif pos = 6 then
        locate (32, 12)
    end if    
    txt ({175})
end procedure

----------------------------------------------------------------------------
-- User selects which overlays will be used on current board
procedure toggle_overlays ()
    integer pos, update, key
    sequence back
    pos = 1            
    update = 1              
    key = 0                   
    cursor (NO_CURSOR)
    back = save_text_image ({5, 10}, {15, 51})
    display_text_image ({5, 10}, overlay_screen)
    locate (12, 6)
    txtf ("@1~FOverlays for board #%d", {current_board})     
    while 1 do
        if update = 1 then  
            overlay_show_pointer (pos)
            update = 0
        end if   
        key = get_key ()
        if key = 27 or key = 'O' or key = 'o' then  -- ESC
            exit    
        end if        
        if key = k_up then  -- UP
            if pos = 1 then
                pos = 3
            elsif pos = 4 then
                pos = 6
            else
                pos = pos - 1
            end if           
            update = 1
        elsif key = k_down then  -- DOWN
            if pos = 3 then
                pos = 1
            elsif pos = 6 then
                pos = 4   
            else
                pos = pos + 1
            end if     
            update = 1
        elsif key = k_left then  -- LEFT
            if pos = 4 then
                pos = 1 
                update = 1
            elsif pos = 5 then
                pos = 2
                update = 1
            elsif pos = 6 then
                pos = 3   
                update = 1
            end if   
        elsif key = k_right then  -- RIGHT
            if pos = 1 then
                pos = 4
                update = 1
            elsif pos = 2 then
                pos = 5
                update = 1
            elsif pos = 3 then
                pos = 6
                update = 1
            end if
        elsif key = ' ' or key = 13 then  -- Enter / space
            if pos = 1 then
                boardinfo[current_board][9] = 0
                boardinfo[current_board][10] = 0
            elsif pos = 2 then
                boardinfo[current_board][9] = 1
            elsif pos = 3 then
                boardinfo[current_board][9] = 2
            elsif pos = 4 then
                boardinfo[current_board][10] = 0
            elsif pos = 5 then
                boardinfo[current_board][10] = 1
                if boardinfo[current_board][9] = 0 then
                    boardinfo[current_board][9] = 1    
                end if                             
            elsif pos = 6 then
                boardinfo[current_board][10] = 2
                if boardinfo[current_board][9] = 0 then
                    boardinfo[current_board][9] = 1    
                end if                 
            end if           
            -- Update total overlays # in boardinfo
            if boardinfo[current_board][9] > 0 and
            boardinfo[current_board][10] > 0 then
                boardinfo[current_board][8] = 2
            elsif boardinfo[current_board][9] > 0 or
            boardinfo[current_board][10] > 0 then 
                boardinfo[current_board][8] = 1
            else
                boardinfo[current_board][8] = 0    
            end if
            update = 1
        end if
    end while          
    -- If player is on an overlay that isn't there ... move 'em down!
    if current_layer = 1 and boardinfo[current_board][9] = 0 then
        current_layer = 0
        reset_current_obj () 
        show_current () 
        draw_appropriate ()
    elsif current_layer = 2 and boardinfo[current_board][10] = 0 then
        current_layer = 0
        reset_current_obj ()
        show_current ()
        draw_appropriate ()
    end if
    display_text_image ({5, 10}, back)
end procedure

----------------------------------------------------------------------------
-- Clears EVERYTHING (different from initial 'clear_world')
procedure user_clear_all ()
    integer yesorno
    yesorno = ask ("Clear ~EEVERYTHING~F: Are you sure?")
    if yesorno = 1 then
        cursor (NO_CURSOR)
        clear_world ()
        draw_sidebar ()
        draw_all_board ()
        cx = 1
        cy = 1            
        cursor (BLOCK_CURSOR)
    end if
end procedure

----------------------------------------------------------------------------
-- Presents a menu of boards for user to select from INCLUDING None!!!
function select_board_withnone (integer startpos)
    sequence back, boards
    integer key, pointer, update
    pointer = startpos + 1
    key = -1                    
    update = 1  
    back = save_text_image ({3, 10}, {23, 51})
    cursor (NO_CURSOR)                            
    -- Build 'boards' sequence, including 'None'
    boards = {"None"}
    for z = 1 to worldinfo[4] do
        boards = append (boards, boardinfo[z][1])   
    end for
    display_text_image ({3, 10}, board_selection_screen)
    txt ("@1~F")
    -- Show boards ...
    while 1 do
        if update = 1 then                
            -- Show list of boards
            for z = pointer to pointer + 6 do
                if z > worldinfo[4] + 1 then
                    locate (17, z - pointer + 13)
                    txt ("                            ")                    
                    exit    
                end if         
                -- 'if' allows display of hilited board (middle)
                if z = pointer then
                    locate (17, z - pointer + 13)
                    txt ("~F@9                            ")
                    locate (18, z - pointer + 13)
                    txt (boards[z]) 
                    txt ("@1")                   
                else
                    locate (18, z - pointer + 13)
                    txt ("~9                         ")
                    locate (18, z - pointer + 13)
                    txt (boards[z])
                end if   
            end for    
            -- Show boards 'on top' if any
            if pointer != 1 then
                for m = pointer - 1 to pointer - 5 by -1 do
                    if m < 1 then
                        locate (17, m - pointer + 13)
                        txt ("                            ")                    
                        exit    
                    end if  
                    locate (18, m - pointer + 13)
                    txt ("~9                         ")
                    locate (18, m - pointer + 13)
                    txt (boards[m])                                        
                end for
            end if
            -- Corrects for a bug ... who knows why I need to do this .....
            if pointer = 1 then
                locate (17, 12)
                txt ("                            ")                
            end if
            update = 0
        end if
        key = get_key ()
        if key = k_up and pointer > 1 then  -- Up
            pointer = pointer - 1    
            update = 1
        elsif key = k_down and pointer < worldinfo[4] + 1 then  -- Down
            pointer = pointer + 1    
            update = 1
        elsif key = 327 and pointer > 1 then  -- Home (top)
            pointer = 1
            display_text_image ({3, 10}, board_selection_screen)
            update = 1         
        elsif key = 335 and pointer < worldinfo[4] then  -- End (bott)
            pointer = worldinfo[4] + 1
            display_text_image ({3, 10}, board_selection_screen)
            update = 1    
        end if
        if key = 27 or key = 13 or key = ' ' or key = 'B' or key = 'b' then
            exit
        end if
    end while
    -- If they pressed ESC, just redraw & send -1
    if key = 27 then
        display_text_image ({3, 10}, back)
        return -1
    else         
        display_text_image ({3, 10}, back)
        return pointer
    end if
end function

----------------------------------------------------------------------------
-- Presents a menu of boards for user to select from ... yay!
function select_board (integer brdnum)
    sequence back
    integer key, pointer, update
    pointer = brdnum         
    key = -1                    
    update = 1  
    back = save_text_image ({3, 10}, {23, 51})
    cursor (NO_CURSOR)
    display_text_image ({3, 10}, board_selection_screen)
    locate (22, 22)
    txt ("@8~EA = Add new board")
    txt ("@1~F")
    -- Show boards ...
    while 1 do
        if update = 1 then                
            -- Show list of boards
            for z = pointer to pointer + 6 do
                if z > worldinfo[4] then
                    locate (17, z - pointer + 13)
                    txt ("                            ")                    
                    exit    
                end if         
                -- 'if' allows display of hilited board (middle)
                if z = pointer then
                    locate (17, z - pointer + 13)
                    txt ("~F@9                            ")
                    locate (18, z - pointer + 13)
                    txt (boardinfo[z][1]) 
                    txt ("@1")                   
                else
                    locate (18, z - pointer + 13)
                    txt ("~9                         ")
                    locate (18, z - pointer + 13)
                    txt (boardinfo[z][1])
                end if   
            end for    
            -- Show boards 'on top' if any
            if pointer != 1 then
                for m = pointer - 1 to pointer - 5 by -1 do
                    if m < 1 then
                        locate (17, m - pointer + 13)
                        txt ("                            ")                    
                        exit    
                    end if  
                    locate (18, m - pointer + 13)
                    txt ("~9                         ")
                    locate (18, m - pointer + 13)
                    txt (boardinfo[m][1])                                        
                end for
            end if
            -- Corrects for a bug ... who knows why I need to do this .....
            if pointer = 1 then
                locate (17, 12)
                txt ("                            ")                
            end if
            -- Updates sidebar
            locate (62, 15)
            txtf ("@1~ABoard: %d~2 / ~A%d  ", {pointer, worldinfo[4]})
            update = 0
        end if
        key = get_key ()
        if key = k_up and pointer > 1 then  -- Up
            pointer = pointer - 1    
            update = 1
        elsif key = k_down and pointer < worldinfo[4] then  -- Down
            pointer = pointer + 1    
            update = 1
        ---- NEW STUFF
        elsif key = 327 and pointer > 1 then  -- Home (top)
            pointer = 1
            display_text_image ({3, 10}, board_selection_screen)
            locate (22, 22)
            txt ("@8~EA = Add new board")
            update = 1         
        elsif key = 335 and pointer < worldinfo[4] then  -- End (bott)
            pointer = worldinfo[4]
            display_text_image ({3, 10}, board_selection_screen)
            locate (22, 22)
            txt ("@8~EA = Add new board")
            update = 1    
        elsif key = 329 then  -- PgUp
            if pointer - 6 < 1 and pointer != 1 then
                pointer = 1
                display_text_image ({3, 10}, board_selection_screen)
                locate (22, 22)
                txt ("@8~EA = Add new board")
                update = 1            
            elsif pointer > 1 then
                pointer = pointer - 6    
                display_text_image ({3, 10}, board_selection_screen)
                locate (22, 22)
                txt ("@8~EA = Add new board")
                update = 1            
            end if                   
        elsif key = 337 then  -- PgDown
            if pointer + 6 > worldinfo[4] and pointer != worldinfo [4] then
                pointer = worldinfo[4]
                display_text_image ({3, 10}, board_selection_screen)
                locate (22, 22)
                txt ("@8~EA = Add new board")
                update = 1            
            elsif pointer < worldinfo[4] then               
                pointer = pointer + 6    
                display_text_image ({3, 10}, board_selection_screen)
                locate (22, 22)
                txt ("@8~EA = Add new board")
                update = 1            
            end if
        elsif key = 'A' or key = 'a' then
            add_board ()
            draw_appropriate ()      
            reset_current_obj ()
            draw_sidebar ()            
            return -2
        end if
        if key = 27 or key = 13 or key = ' ' or key = 'B' or key = 'b' then
            exit
        end if
    end while
    -- If they pressed ESC, just redraw & send -1
    if key = 27 then
        display_text_image ({3, 10}, back)
        return -1
    else         
        display_text_image ({3, 10}, back)
        return pointer
    end if
end function

----------------------------------------------------------------------------
-- Used in board info editing ... shows exits from current board
procedure show_exits ()
    locate (24, 9)                  
    txt ("@4~F")
    txt (boardinfo [current_board][1])             
    locate (39, 11)  
    txt_int (boardinfo [current_board][2])  
    -- Mod name
    locate (25, 18)
    --print (1, boardinfo[current_board][7])
    --junk = wait_key ()
    txt (boardinfo [current_board][7])
    -- UP
    locate (23, 13)
    if boardinfo[current_board][3] > 0 then
        txt (boardinfo[boardinfo[current_board][3]][1])
    else
        txt ("None")        
    end if
    -- DOWN
    locate (23, 14)
    if boardinfo[current_board][4] > 0 then
        txt (boardinfo[boardinfo[current_board][4]][1])
    else
        txt ("None")        
    end if
    -- LEFT
    locate (23, 15)
    if boardinfo[current_board][5] > 0 then
        txt (boardinfo[boardinfo[current_board][5]][1])
    else
        txt ("None")        
    end if                 
    -- RIGHT
    locate (23, 16)
    if boardinfo[current_board][6] > 0 then
        txt (boardinfo[boardinfo[current_board][6]][1])
    else
        txt ("None")        
    end if    
end procedure

----------------------------------------------------------------------------
-- Allows user to edit board information! Wheee!
procedure board_info_edit (integer pointer)
    object newtitle, oldtitle
    integer key, tx, ty, newboard
    object tempnum
    newtitle = ""              
    oldtitle = boardinfo [current_board] [1]
    key = -1           
    -- Different action depending on pointer #
    if pointer = 1 then  -- New board name
        txt ("@0~F")    
        newtitle = getstr (24, 9, 25)
        -- If just Enter pressed, reset title
        if atom (newtitle) = 0 then
        if compare (newtitle, "") = 0 then
            newtitle = oldtitle
            boardinfo [current_board] [1] = oldtitle   
        else  -- Else, set the boardinfo title to the new ... uh, title ;)
            boardinfo [current_board] [1] = newtitle
        end if          
        end if
    elsif pointer = 2 then  -- # of shots at a time
        txt ("@0~F")
        tempnum = getint (39, 11, 4)
        if integer (tempnum) then
            if tempnum > 255 or tempnum <= -1 then
                tempnum = 255
            end if   
            boardinfo [current_board] [2] = tempnum
        end if
    elsif pointer = 3 then  -- Board 'up'
        newboard = select_board_withnone (boardinfo[current_board][3])
        if newboard != -1 then
            boardinfo[current_board][3] = newboard - 1
        end if
    elsif pointer = 4 then  -- Board 'down'
        newboard = select_board_withnone (boardinfo[current_board][4])
        if newboard != -1 then
            boardinfo[current_board][4] = newboard - 1
        end if
    elsif pointer = 5 then  -- Board 'left'
        newboard = select_board_withnone (boardinfo[current_board][5])
        if newboard != -1 then
            boardinfo[current_board][5] = newboard - 1
        end if                        
    elsif pointer = 6 then  -- Board 'right'
        newboard = select_board_withnone (boardinfo[current_board][6])
        if newboard != -1 then
            boardinfo[current_board][6] = newboard - 1
        end if
    elsif pointer = 7 then  -- MOD
        if compare (boardinfo[current_board][7], "None") = 0 then        
            tempseq = dirlist ("MOD music file", "*.MOD")
            if atom (tempseq) = 0 then
                unload_mod ()
                junk = init_modwave (STEREO, 44100, 20)        
                volume_up ()
                junk = load_mod (tempseq)  
                --print (1, tempseq)
                --junk = wait_key ()
                boardinfo[current_board][7] = upper (tempseq)
            end if                                        
        else  -- Turn off mod if one is already playing
            boardinfo[current_board][7] = "None"
            unload_mod ()
        end if    
    end if                   
    cursor (NO_CURSOR)                       
    -- After editing, clean up the [whatever]
    if pointer = 1 then
        locate (24, 9)
        txt ("@4~F                         ")                
        locate (24, 9)
        txt (newtitle)
    end if
end procedure

----------------------------------------------------------------------------
-- User selects board information (incl. exits) to be edited
procedure board_info ()
    integer pointer, key, ppos
    sequence back
    back = save_text_image ({5, 5}, {21, 56})
    pointer = 1               
    ppos = 1
    key = -1  
    cursor (NO_CURSOR)
    display_text_image ({5, 5}, board_info_screen)
    -- Show exits from board, if any
    show_exits ()
    while 1 do
        -- Show the pointer
        if pointer < 3 then   
            ppos = pointer * 2 + 7
        elsif pointer < 7 then
            ppos = pointer + 10
        else
            ppos = pointer * 2 + 4
        end if
        locate (7, ppos)
        txt ("@1~E")
        txt ({175})
        key = get_key ()
        if key = k_up then  -- Up     
            locate (7, ppos)
            txt ("@1~E ")
            if pointer = 1 then
                pointer = 7
            else
                pointer = pointer - 1    
            end if                   
        elsif key = k_down then  -- Down
            locate (7, ppos)
            txt ("@1~E ")
            if pointer = 7 then
                pointer = 1
            else
                pointer = pointer + 1
            end if 
        elsif key = 13 or key = ' ' then  -- Select option (run editor)
            board_info_edit (pointer)                 
            display_text_image ({5, 5}, board_info_screen)            
            show_exits ()
        elsif key = 27 or key = 'B' or key = 'b' then  -- ESC
            exit
        end if
    end while
    display_text_image ({5, 5}, back)
    cursor (BLOCK_CURSOR)
end procedure   

----------------------------------------------------------------------------
-- 2nd show world info thingie
procedure show_world_info2 ()
    sequence tempcolor
    -- Other stuff (startboard, bulletdamage, dfltmesgcolor, mesg edges)
    locate (25, 7)                  
    txt ("@4~F")
    txt (boardinfo[worldinfo[36]][1])      
    locate (33, 8)
    txt ("@4~F")
    txt_int (worldinfo[37])
    locate (32, 9)
    tempcolor = attrib2colors (worldinfo[38])
    set_color (tempcolor [1])
    set_bkcolor (tempcolor [2])
    txt ("  ")
    locate (10, 10)
    if worldinfo[39] = 1 then  
        txt ("@1~E")
        txt ({251})    
    end if
    -- Player bullet color / chars
    locate (32, 11)
    tempcolor = attrib2colors (worldinfo[26])
    set_color (tempcolor [1])
    set_bkcolor (tempcolor [2])
    txt ("  ")                   
    locate (35, 12)
    txt ({worldinfo[27]})
    locate (35, 13)
    txt ({worldinfo[28]})
    locate (35, 14)
    txt ({worldinfo[29]})
    locate (35, 15)
    txt ({worldinfo[30]})    
    -- Robot bullet color / chars
    locate (32, 16)
    tempcolor = attrib2colors (worldinfo[31])
    set_color (tempcolor [1])
    set_bkcolor (tempcolor [2])
    txt ("  ")                   
    locate (35, 17)
    txt ({worldinfo[32]})
    locate (35, 18)
    txt ({worldinfo[33]})
    locate (35, 19)
    txt ({worldinfo[34]})
    locate (35, 20)
    txt ({worldinfo[35]})  
end procedure                

----------------------------------------------------------------------------
-- The 2nd place where the user actually edits the world info ... yeah.
procedure world_info_edit2 (integer pos)
    object ans, tempseq                           
    txt ("@0~F")
    if pos = 1 then  -- Starting board
        ans = select_board (worldinfo[36])
        if ans > 0 then
            worldinfo[36] = ans                
        end if
    elsif pos = 2 then  -- Bullet damage 
        ans = getint (33, 8, 3)
        if atom (ans) then
            if ans > -1 then
                worldinfo[37] = ans    
            end if
        end if
    elsif pos = 3 then  -- Default mesg color
        ans = choose_color (attrib2colors(worldinfo[38]))
        if ans[1] != -1 then
            worldinfo[38] = ans[1] + (ans[2] * 16)    
        end if
    elsif pos = 4 then  -- Mesg edge? Or no?
        if worldinfo[39] = 1 then
            worldinfo[39] = 0
        else
            worldinfo[39] = 1    
        end if
    elsif pos = 5 then  -- Player bulletcolor       
        ans = choose_color (attrib2colors(worldinfo[26]))
        if ans[1] != -1 then
            worldinfo[26] = ans[1] + (ans[2] * 16)    
        end if
    elsif pos = 6 then  -- Player bullet up
        tempseq = attrib2colors(worldinfo[26])
        ans = choose_char (worldinfo[27], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[27] = ans    
        end if
    elsif pos = 7 then  -- Player bullet down
        tempseq = attrib2colors(worldinfo[26])
        ans = choose_char (worldinfo[28], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[28] = ans    
        end if
    elsif pos = 8 then  -- Player bullet left
        tempseq = attrib2colors(worldinfo[26])
        ans = choose_char (worldinfo[29], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[29] = ans    
        end if                    
    elsif pos = 9 then  -- Player bullet right
        tempseq = attrib2colors(worldinfo[26])
        ans = choose_char (worldinfo[30], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[30] = ans    
        end if                 
    elsif pos = 10 then  -- Robot bulletcolor       
        ans = choose_color (attrib2colors(worldinfo[31]))
        if ans[1] != -1 then
            worldinfo[31] = ans[1] + (ans[2] * 16)    
        end if    
    elsif pos = 11 then  -- Robot bullet up
        tempseq = attrib2colors (worldinfo[31])
        ans = choose_char (worldinfo[32], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[32] = ans    
        end if
    elsif pos = 12 then  -- Robot bullet down
        tempseq = attrib2colors (worldinfo[31])
        ans = choose_char (worldinfo[33], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[33] = ans    
        end if
    elsif pos = 13 then  -- Robot bullet left
        tempseq = attrib2colors (worldinfo[31])
        ans = choose_char (worldinfo[34], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[34] = ans    
        end if
    elsif pos = 14 then  -- Robot bullet right
        tempseq = attrib2colors (worldinfo[31])
        ans = choose_char (worldinfo[35], tempseq[1], tempseq[2])
        if ans != -1 then
            worldinfo[35] = ans    
        end if
    end if                     
    -- Clean up
    show_world_info2 () 
    cursor (NO_CURSOR)
end procedure

----------------------------------------------------------------------------
-- The 2nd world info screen!
function world_info2 ()
    integer key, update, pos
    update = 1              
    pos = 1
    draw_appropriate ()
    display_text_image ({3, 5}, worldinfo2_screen)
    locate (9, 11)
    set_color (worldinfo[9])
    set_bkcolor (worldinfo[10])
    txt ({worldinfo[5]})
    show_world_info2 ()
    while 1 do         
        if update = 1 then 
            locate (7, pos + 6)
            txt ("@1~E")
            txt ({175})
            update = 0                
        end if
        key = get_key ()
        if key = 27 or key = 329 then  -- ESC or PgUp
            exit    
        end if
        if key = k_up then
            locate (7, pos + 6)
            txt (" ")
            if pos = 1 then
                pos = 14
            else
                pos = pos - 1    
            end if         
            update = 1  
        elsif key = k_down then
            locate (7, pos + 6)
            txt (" ")
            if pos = 14 then
                pos = 1
            else
                pos = pos + 1    
            end if   
            update = 1
        elsif key = 13 or key = ' ' then
            world_info_edit2 (pos)
            display_text_image ({3, 5}, worldinfo2_screen)
            locate (9, 11)
            set_color (worldinfo[9])
            set_bkcolor (worldinfo[10])
            txt ({worldinfo[5]})
            show_world_info2 ()
            update = 1            
        end if
    end while
    --display_text_image ({3, 5}, back)
    if key = 329 then
        return "stay"
    else
        return "quit"    
    end if
end function

----------------------------------------------------------------------------
-- Used in world info editing thingie ...
procedure show_world_info ()
    cursor (NO_CURSOR)
    txt ("@4~F")
    locate (21, 6)        
    txt (worldinfo[1])
    locate (22, 7)
    txt (worldinfo[2])
    locate (29, 8)
    txtf ("@1~7%d / %d / %d", {worldinfo[15], worldinfo[16], worldinfo[17]})   
    locate (23, 10)
    set_color (worldinfo[9])
    set_bkcolor (worldinfo[10])
    txt ("  ")
    locate (28, 11)  -- Player char UP
    txt ({worldinfo[5]}) 
    locate (28, 12)  -- Player char DOWN
    txt ({worldinfo[6]}) 
    locate (28, 13)  -- Player char LEFT
    txt ({worldinfo[7]}) 
    locate (28, 14)  -- Player char RIGHT
    txt ({worldinfo[8]}) 
    locate (30, 15)  -- Start health
    txtf ("@4~F%d", {worldinfo[11]})
    locate (30, 16)
    txtf ("%d", {worldinfo[12]}) 
    if worldinfo [13] = 1 then  -- If message on player death
        locate (10, 20)
        txt ("@1~E")
        txt ({7})
        locate (10, 19)
        txt (" ")
        txt ("@4~F")
        locate (22, 20)
        txt (worldinfo [14])
    else  -- If teleport to board
        locate (10, 19)
        txt ("@1~E")
        txt ({7})
        locate (10, 20)
        txt (" ")
        locate (30, 19)
        txt ("@4~F")
        txt (boardinfo[worldinfo [14]][1])            
    end if
end procedure

----------------------------------------------------------------------------
-- Allows user to actually edit the ... things. And the stuff, too.
procedure world_info_edit (integer pointer)
    integer update, tempnum
    object tempstr
    tempstr = ""  
    update = 0
    if pointer = 1 then  -- World name
        txt ("@0~F")
        tempstr = getstr (21, 6, 18)   
        update = 1
        if atom (tempstr) = 0 then
        if compare (tempstr, "") != 0 then
            worldinfo [1] = tempstr    
        end if
        end if
    elsif pointer = 2 then  -- Author name
        txt ("@0~F")
        tempstr = getstr (22, 7, 18)          
        update = 1
        if atom (tempstr) = 0 then
        if compare (tempstr, "") != 0 then
            worldinfo [2] = tempstr
        end if    
        end if
    elsif pointer = 4 then  -- Player color
        tempstr = choose_color ({worldinfo[9], worldinfo[10]})
        if tempstr [1] != -1 then
            worldinfo [9] = tempstr [1]
            worldinfo [10] = tempstr [2]
            show_current ()
            -- Now change player color on all boards ... ick
            for z = 1 to worldinfo [4] do
                for q = 1 to 25 do
                    for n = 1 to 60 do
                        if main[z][n][q][1] = 9 then
                            main[z][n][q][4] = tempstr [1]
                            main[z][n][q][5] = tempstr [2]
                            exit    
                        end if
                    end for
                end for
            end for       
            -- End of player scan
        end if
    elsif pointer = 5 then  -- Player char UP
        tempnum = choose_char (worldinfo[5], worldinfo[9], worldinfo[10])
        if tempnum != -1 then
            worldinfo [5] = tempnum
            -- Replace player char (for showing on edit screen)
            for z = 1 to worldinfo [4] do
                for q = 1 to 25 do
                    for n = 1 to 60 do
                        if main[z][n][q][1] = 9 then
                            main[z][n][q][2] = tempnum
                            exit    
                        end if
                    end for
                end for
            end for       
            -- End of player scan
        end if
    elsif pointer = 6 then  -- Player char DOWN
        tempnum = choose_char (worldinfo[6], worldinfo[9], worldinfo[10])
        if tempnum != -1 then
            worldinfo [6] = tempnum
        end if
    elsif pointer = 7 then  -- Player char LEFT
        tempnum = choose_char (worldinfo[7], worldinfo[9], worldinfo[10])
        if tempnum != -1 then
            worldinfo [7] = tempnum
        end if
    elsif pointer = 8 then  -- Player char RIGHT
        tempnum = choose_char (worldinfo[8], worldinfo[9], worldinfo[10])
        if tempnum != -1 then
            worldinfo [8] = tempnum
        end if
    elsif pointer = 9 then  -- Player start health
        txt ("@0~F")
        tempnum = getint (30, 15, 3)
        if integer (tempnum) = 1 then
            if tempnum <= 0 then
                tempnum = 1
            end if 
            if tempnum > worldinfo [12] then  -- Makes sure start <= max
                worldinfo [11] = worldinfo [12]
            else
                worldinfo [11] = tempnum
            end if
        end if
    elsif pointer = 10 then  -- Player MAX health
        txt ("@0~F")
        tempnum = getint (30, 16, 3)
        if integer (tempnum) = 1 then
            if tempnum <= 0 then
                tempnum = 1
            end if
            if tempnum < worldinfo [11] then  -- Makes sure is max >= start
                worldinfo [12] = worldinfo [11]
            else
                worldinfo [12] = tempnum  
            end if
        end if    
    elsif pointer = 11 then  -- Set death action to 'teleport'
        txt ("@0~F")
        tempnum = select_board (1)
        if tempnum != -1 then
            worldinfo [14] = tempnum  
            worldinfo [13] = 0
        end if        
    elsif pointer = 12 then  -- Set death action to 'message'
        txt ("@0~F")
        tempstr = getstr (22, 20, 33)
        if atom (tempstr) = 0 then
        if compare (tempstr, "") != 0 then
            worldinfo [14] = tempstr  
            worldinfo [13] = 1
        end if        
        end if
    end if
    -- After the if ... CLEANUP
    cursor (NO_CURSOR)
    display_text_image ({2, 5}, worldinfo_screen)
    if update = 1 then
        draw_sidebar ()   
    end if
    show_world_info ()
end procedure

----------------------------------------------------------------------------
-- World info select-which-one-you're-going-to-edit screen!
procedure world_info ()
    sequence back, menu, retval
    integer pointer, key, update 
    key = -1
    pointer = 1                 
    update = 1                   
    cursor (NO_CURSOR)
    back = save_text_image ({2, 5}, {24, 56})
    display_text_image ({2, 5}, worldinfo_screen)
    if worldinfo [13] = 0 then
        locate (10, 19)
        txt ("@1~E")
        txt ({251})
    else
        locate (10, 20)
        txt ("@1~E")
        txt ({251})       
    end if
    show_world_info ()                    
    -- Move pointer
    while 1 do
        cursor (NO_CURSOR)
        if update = 1 then 
            -- Show arrow
            if pointer >= 1 and pointer <= 3 then
                locate (7, pointer + 5)
            elsif pointer >= 4 and pointer <= 10 then
                locate (7, pointer + 6)
            else
                locate (7, pointer + 8)
            end if 
            txt ("@1~E")
            txt ({175})
            update = 0
        end if  
        key = get_key ()         
        -- Erase old pointer ...
        if key = k_up or key = k_down then  
            if pointer >= 1 and pointer <= 3 then
                locate (7, pointer + 5)
            elsif pointer >= 4 and pointer <= 10 then
                locate (7, pointer + 6)
            else
                locate (7, pointer + 8)
            end if       
            txt (" ")                              
        end if                  
        -- Check for movement of pointer
        if key = k_up then  -- Up
            if pointer = 1 then
                pointer = 12
            else
                pointer = pointer - 1    
            end if                   
            update = 1
        elsif key = k_down then  -- Down
            if pointer = 12 then
                pointer = 1
            else
                pointer = pointer + 1    
            end if   
            update = 1
        elsif key = ' ' or key = 13 then
            world_info_edit (pointer)      
            show_world_info ()                    
            update = 1                         
            clear_buff ()  
        elsif key = 337 then  -- PgDown (other worldinfo screen)
            retval = world_info2 ()
            if compare (retval, "quit") = 0 then 
                exit                             
            end if    
            display_text_image ({2, 5}, worldinfo_screen)
            show_world_info ()
            update = 1
        end if
        if key = 27 then
            exit    
        end if
    end while         
    cursor (BLOCK_CURSOR)
end procedure   

----------------------------------------------------------------------------
-- Durrr ... resets ROM char set
procedure set_default_chars ()
    for z = 1 to 256 do
        add_font (z-1, default_charset[z])    
    end for
end procedure

----------------------------------------------------------------------------
-- Show the little box with the char in it ... for using +/- ... you know!!!
procedure char_show_scroll_list (integer cchar)
    integer cnt
    txt ("@1~F")
    -- Show char itself, then ones after it
    locate (41, 5)
    txt ({cchar-1})  
    txt ("~0")
    cnt = cchar
    for z = 1 to 12 do
        cnt = cnt + 1
        if cnt > 256 then
            cnt = 0    
        end if     
        locate (41+z, 5) 
        txt ({cnt-1})
    end for
    -- Show ones BEFORE it 
    cnt = cchar
    for z = 1 to 12 do
        cnt = cnt - 1
        if cnt < 0 then
            cnt = 255    
        end if       
        locate (41-z, 5)
        txt ({cnt-1})
    end for
end procedure

----------------------------------------------------------------------------
-- Show cursor for char editing
procedure char_show_cursor (integer tx, integer ty, integer cchar)
    sequence tempset
    integer val     
    tempset = curr_charset
    val = 256       
    for p = 1 to 8 do                        
        locate ((p*2) + 9, ty + 3)
        val = floor (val / 2)  
        set_bkcolor (8)
        if tempset[cchar][ty] - val >= 0 then
            tempset[cchar][ty] = tempset[cchar][ty] - val
            if p = tx then
                txt ("~B")
            else
                txt ("~F")                
            end if
        else
            if p = tx then
                txt ("~B@3") 
            else
                txt ("~7") 
            end if   
        end if
    end for       
end procedure

----------------------------------------------------------------------------
-- Remove cursor from char editing (clear it)
procedure char_rm_cursor (integer tx, integer ty, integer cchar)
    sequence tempset
    integer val     
    tempset = curr_charset
    val = 256       
    for p = 1 to 8 do                        
        locate ((p*2) + 9, ty + 3)
        val = floor (val / 2)  
        set_bkcolor (1)
        if tempset[cchar][ty] - val >= 0 then
            tempset[cchar][ty] = tempset[cchar][ty] - val
            txt ("@8~F")                
        else
            txt ("@8~7")   
        end if
    end for       
end procedure

----------------------------------------------------------------------------
-- Show current char being edited (whole thing)
procedure char_show_editing (integer charnum)
    integer val             
    sequence tempset
    tempset = curr_charset
    txt ("~7@8")
    for t = 1 to 14 do
        val = 256
        set_bkcolor (1)
        for p = 1 to 8 do                        
            locate ((p*2) + 9, t + 3)
            val = floor (val / 2)  
            if tempset[charnum][t] - val >= 0 then
                tempset[charnum][t] = tempset[charnum][t] - val
                txt ("@8~F")
            else
                txt ("@8~7")    
            end if
        end for       
        locate (7, t + 3)
        txt ("@1~9")
        if curr_charset[charnum][t] < 10 then
            txt ("00")
        elsif curr_charset[charnum][t] < 100 then
            txt ("0")
        end if
        txt_int (curr_charset[charnum][t])
    end for         
end procedure

----------------------------------------------------------------------------
-- Sets / clears target pixel on cchar
procedure char_toggle_pixel (integer cchar, integer tx, integer ty)
    integer val, editnum
    val = 256          
    editnum = curr_charset[cchar][ty]
    for p = 1 to 8 do                        
        val = floor (val / 2)  
        if editnum - val >= 0 and p != tx then
            editnum = editnum - val
        end if
    end for            
    if editnum = 0 then    
        curr_charset[cchar][ty] = curr_charset[cchar][ty] + power (2, (8-tx))
    else
        curr_charset[cchar][ty] = curr_charset[cchar][ty] - power (2, (8-tx))                
    end if                       
end procedure

----------------------------------------------------------------------------
-- Character editor: MAIN routine
procedure char_edit ()
    sequence back
    integer tx, ty, key, update, cchar, val, editnum, tempint
    cchar = lastcharedit
    tx = 1
    ty = 1                     
    update = 1
    cursor (NO_CURSOR)
    back = save_text_image ({2, 5}, {22, 56})
    display_text_image ({2, 5}, char_edit_screen)
    char_show_scroll_list (cchar)
    char_show_editing (cchar)
    update = 1
    while 1 do
        if update = 1 then
            char_show_cursor (tx, ty, cchar)
            char_show_scroll_list (cchar)
            -- Next few parts show current char #
            locate (23, 19)
            txt ("@1~E")
            if cchar < 10 then
                txt ("00")
            elsif cchar < 100 then
                txt ("0")
            end if         
            txt_int (cchar-1)  
            -- Now the little preview thing ...
            locate (7, 19) 
            txt ("@0~F")
            txt ({cchar-1})    
            txt ({cchar-1})    
            txt ({cchar-1})                
            locate (7, 20) 
            txt ({cchar-1})    
            txt ({cchar-1})    
            txt ({cchar-1})                
            update = 0    
        end if        
        key = get_key () 
        -- Keyreads start!!!#$@
        if key = ' ' then  -- Toggle pixel            
            char_toggle_pixel (cchar, tx, ty)
            char_show_editing (cchar)        
            add_font (cchar-1, curr_charset[cchar])  
            update = 1
        elsif key = k_up then
            char_rm_cursor (tx, ty, cchar)
            if ty = 1 then
                ty = 14
            else
                ty = ty - 1    
            end if         
            update = 1 
        elsif key = k_down then
            char_rm_cursor (tx, ty, cchar)
            if ty = 14 then
                ty = 1
            else
                ty = ty + 1    
            end if         
            update = 1
        elsif key = k_left then
            char_rm_cursor (tx, ty, cchar)
            if tx = 1 then
                tx = 8
            else
                tx = tx - 1    
            end if         
            update = 1
        elsif key = k_right then
            char_rm_cursor (tx, ty, cchar)
            if tx = 8 then
                tx = 1
            else
                tx = tx + 1    
            end if         
            update = 1
        elsif key = '+' or key = '=' then  -- Advance 
            if cchar = 256 then
                cchar = 1
            else
                cchar = cchar + 1    
            end if               
            char_show_editing (cchar)
            update = 1
        elsif key = '-' or key = '_' then  -- Devance (Da Vance? Kev Vance?)
            if cchar = 1 then
                cchar = 256
            else
                cchar = cchar - 1
            end if               
            char_show_editing (cchar)
            update = 1
        elsif key = 13 then  -- Enter: Select char
            tempint = choose_char (cchar-1, 7, 0)
            if tempint != -1 then
                cchar = tempint + 1
                char_show_editing (cchar)
                update = 1                                    
            end if         
            cursor (NO_CURSOR)
        elsif key = 339 then  -- Del: Clear char
            curr_charset[cchar] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0}
            char_show_editing (cchar)
            add_font (cchar-1, curr_charset[cchar])  
            update = 1                               
        elsif key = 'D' or key = 'd' then  -- Restore default char
            curr_charset[cchar] = default_charset[cchar]
            char_show_editing (cchar)
            add_font (cchar-1, curr_charset[cchar])  
            update = 1         
        elsif key = 288 then  -- Alt-D: Restore all chars
            curr_charset = default_charset
            char_show_editing (cchar)
            set_default_chars ()  
            update = 1     
        elsif key = 408 then  -- Alt-Up: Scroll char up     
            tempint = curr_charset[cchar][1]
            for z = 2 to 14 do
                curr_charset[cchar][z-1] = curr_charset[cchar][z]    
            end for                                              
            curr_charset[cchar][14] = tempint
            char_show_editing (cchar)
            add_font (cchar-1, curr_charset[cchar])  
            update = 1                     
        elsif key = 416 then  -- Alt-Down: Scroll char down
            tempint = curr_charset[cchar][14]
            for z = 14 to 2 by -1 do
                curr_charset[cchar][z] = curr_charset[cchar][z-1]    
            end for                                              
            curr_charset[cchar][1] = tempint
            char_show_editing (cchar)
            add_font (cchar-1, curr_charset[cchar])  
            update = 1                                 
        elsif key = 411 then  -- Alt-Left: Scroll char left 
        
        elsif key = 'N' or key = 'n' then  -- Do 'negative' (reverse)
            for z = 1 to 16 do
                for p = 1 to 8 do
                    char_toggle_pixel (cchar, p, z)    
                end for
            end for                                
            char_show_editing (cchar)        
            add_font (cchar-1, curr_charset[cchar])  
            update = 1            
        elsif key = 'C' or key = 'c' or key = 302 then  -- Copy char
            clipboard_char = curr_charset[cchar]
        elsif key = 'P' or key = 'p' or key = 281 then  -- Paste!
            curr_charset[cchar] = clipboard_char
            char_show_editing (cchar)        
            add_font (cchar-1, curr_charset[cchar])  
            update = 1                        
        end if
        if key = 27 then
            exit    
        end if
    end while
    display_text_image ({2, 5}, back)
end procedure
              
----------------------------------------------------------------------------
-- Palette editor
procedure palette_edit ()                                
    integer pos, key, update
    sequence back
    object clr
    back = save_text_image ({5, 5}, {19, 56})
    pos = 0         
    key = -1                
    update = 1                 
    cursor (NO_CURSOR)
    display_text_image ({5, 5}, palette_edit_screen)
    -- Clrbars
    for z = 0 to 15 do
        locate (7 + (z * 3), 9)
        set_color (z)
        txt ("")    
    end for         
    while 1 do
        if update = 1 then  
            -- Color #
            txt ("@1~E")
            locate (14, 12)
            if pos < 10 then
                txt ("0")    
            end if       
            txt_int (pos)
            -- Color RGB vals
            -- Red
            locate (26, 12) 
            if curr_palette [pos+1][1] < 10 then
                txt ("0")                    
            end if           
            txt_int (curr_palette [pos+1][1])   
            -- Green
            locate (38, 12) 
            if curr_palette [pos+1][2] < 10 then
                txt ("0")                    
            end if           
            txt_int (curr_palette [pos+1][2])    
            -- Blue
            locate (50, 12) 
            if curr_palette [pos+1][3] < 10 then
                txt ("0")                    
            end if           
            txt_int (curr_palette [pos+1][3])
            -- Pointer            
            locate (8 + (pos * 3), 10)   
            txt ("@1~E")
            txt ({30})
            update = 0 
        end if  
        key = get_key ()
        if key = 27 then
            exit    
        end if        
        if key = k_left or key = '-' or key = '_' then
            locate (8 + (pos * 3), 10)   
            txt (" ")
            if pos = 0 then
                pos = 15
            else
                pos = pos - 1    
            end if           
            update = 1
        elsif key = k_right or key = '+' or key = '=' then
            locate (8 + (pos * 3), 10)   
            txt (" ")
            if pos = 15 then
                pos = 0
            else
                pos = pos + 1    
            end if           
            update = 1
        elsif key = 'R' or key = 'r' then
            if curr_palette [pos+1][1] < 63 then
                curr_palette [pos+1][1] = curr_palette [pos+1][1] + 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1
        elsif key = 'G' or key = 'g' then
            if curr_palette [pos+1][2] < 63 then
                curr_palette [pos+1][2] = curr_palette [pos+1][2] + 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1
        elsif key = 'B' or key = 'b' then
            if curr_palette [pos+1][3] < 63 then
                curr_palette [pos+1][3] = curr_palette [pos+1][3] + 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1
        elsif key = 275 then  -- Alt+R
            if curr_palette [pos+1][1] > 0 then
                curr_palette [pos+1][1] = curr_palette [pos+1][1] - 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1
        elsif key = 290 then  -- Alt+G
            if curr_palette [pos+1][2] > 0 then
                curr_palette [pos+1][2] = curr_palette [pos+1][2] - 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1                           
        elsif key = 304 then  -- Alt+B
            if curr_palette [pos+1][3] > 0 then
                curr_palette [pos+1][3] = curr_palette [pos+1][3] - 1
            end if    
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1          
        elsif key = '0' then
            curr_palette [pos+1] = {0, 0, 0}
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1
        elsif key = 'W' or key = 'w' then
            curr_palette [pos+1] = {63, 63, 63}
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1   
        elsif key = 'D' or key = 'd' then
            curr_palette [pos+1] = default_palette [pos+1]
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1               
        elsif key = 288 then  -- Alt-D: Reset default
            curr_palette = default_palette
            all_palette (curr_palette)
            update = 1   
        elsif key = k_up then  -- Inc all of 'em
            if curr_palette [pos+1][1] < 63 then
                curr_palette [pos+1][1] = curr_palette [pos+1][1] + 1
            end if    
            if curr_palette [pos+1][2] < 63 then
                curr_palette [pos+1][2] = curr_palette [pos+1][2] + 1
            end if    
            if curr_palette [pos+1][3] < 63 then
                curr_palette [pos+1][3] = curr_palette [pos+1][3] + 1
            end if                
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1                      
        elsif key = k_down then  -- Dec all of 'em
            if curr_palette [pos+1][1] > 0 then
                curr_palette [pos+1][1] = curr_palette [pos+1][1] - 1
            end if    
            if curr_palette [pos+1][2] > 0 then
                curr_palette [pos+1][2] = curr_palette [pos+1][2] - 1
            end if    
            if curr_palette [pos+1][3] > 0 then
                curr_palette [pos+1][3] = curr_palette [pos+1][3] - 1
            end if                
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1                      
        elsif key = 302 or key = 'C' or key = 'c' then  -- Alt+C: Copy
            clipboard_color = curr_palette [pos+1]    
        elsif key = 281 or key = 'P' or key = 'p' then  -- Alt+P: Paste     
            curr_palette [pos+1] = clipboard_color
            clr = palette (pos, curr_palette [pos+1])                                               
            update = 1                                  
        end if
    end while
    display_text_image ({5, 5}, back)
end procedure

----------------------------------------------------------------------------
-- Shows vars for editing of message box
procedure update_messagebox (integer ppos)
    sequence clrseq                     
    -- Show cursor position
    txt ("@1~E")
    locate (12, ppos)
    txt ({175})    
    -- Corner positions {topx, topy, botx, boty}
    txt ("@4~F")
    locate (46, 8) 
    txt_int (worldinfo[18])   
    locate (46, 9) 
    txt_int (worldinfo[19])   
    locate (46, 10) 
    txt_int (worldinfo[20])   
    locate (46, 11) 
    txt_int (worldinfo[21]) 
    -- Colors {base, outline, title}
    locate (29, 13)      
    clrseq = attrib2colors (worldinfo[22])
    set_color (clrseq[1])                
    set_bkcolor (clrseq[2])
    txt ("  ")                    
    locate (29, 14)      
    clrseq = attrib2colors (worldinfo[23])
    set_color (clrseq[1])                
    set_bkcolor (clrseq[2])
    txt ("  ")                    
    locate (29, 15)      
    clrseq = attrib2colors (worldinfo[24])
    set_color (clrseq[1])                
    set_bkcolor (clrseq[2])
    txt ("  ")  
    -- Message header? 
    txt ("@1~E")
    locate (15, 17)
    if worldinfo[25] = 1 then
        txt ({251})
    else
        txt (" ")    
    end if
end procedure                           

----------------------------------------------------------------------------
-- Allows user to edit messagebox values
procedure do_edit_messagebox (integer pointer)
    object ans
    txt ("@0~F")
    -- Top Left Corner _X_
    if pointer = 1 then
        ans = getint (46, 8, 2)    
        if integer (ans) = 1 then
            if ans <= 0 then
                worldinfo[18] = 1
            elsif ans >= worldinfo[20] - 5 then
                worldinfo[18] = worldinfo[20] - 5
            else
                worldinfo[18] = ans
            end if
        end if            
    -- Top Left Corner _Y_
    elsif pointer = 2 then
        ans = getint (46, 9, 2)    
        if integer (ans) = 1 then
            if ans <= 0 then
                worldinfo[19] = 1
            elsif ans >= worldinfo[21] - 4 then
                worldinfo[19] = worldinfo[21] - 4
            else
                worldinfo[19] = ans
            end if
        end if            
    -- Bottom Right Corner _X_
    elsif pointer = 3 then
        ans = getint (46, 10, 2)    
        if integer (ans) = 1 then
            if ans > 60 then
                worldinfo[20] = 60
            elsif ans <= worldinfo[18] + 5 then
                worldinfo[20] = worldinfo[18] + 5
            else
                worldinfo[20] = ans
            end if
        end if        
    -- Bottom Right Corner _Y_
    elsif pointer = 4 then
        ans = getint (46, 11, 2)    
        if integer (ans) = 1 then
            if ans > 25 then
                worldinfo[21] = 25
            elsif ans < worldinfo[19] + 4 then
                worldinfo[21] = worldinfo[19] + 4
            else
                worldinfo[21] = ans
            end if
        end if            
    -- Base color
    elsif pointer = 5 then
        ans = choose_color (attrib2colors(worldinfo[22]))
        if ans[1] != -1 then
            worldinfo[22] = ans[1] + (ans[2] * 16)    
        end if
    -- Outline color
    elsif pointer = 6 then
        ans = choose_color (attrib2colors(worldinfo[23]))
        if ans[1] != -1 then
            worldinfo[23] = ans[1] + (ans[2] * 16)    
        end if
    -- Base color
    elsif pointer = 7 then
        ans = choose_color (attrib2colors(worldinfo[24]))
        if ans[1] != -1 then
            worldinfo[24] = ans[1] + (ans[2] * 16)    
        end if          
    -- Header?
    elsif pointer = 8 then
        if worldinfo[25] = 1 then
            worldinfo[25] = 0
        else
            worldinfo[25] = 1    
        end if
    end if
    cursor (NO_CURSOR)
end procedure                    

----------------------------------------------------------------------------
-- Show what message box will look like! Yay!
procedure preview_messagebox ()
    sequence tempclr, tempstr, title
    integer maxmesglen, cpos        
    title = "Test Message Box"
    colorfill (1, 1, 60, 25, 0)                                     
    -- Middle (base)
    tempclr = attrib2colors (worldinfo[22])
    set_color (tempclr[1])
    set_bkcolor (tempclr[2])
    colorfill (worldinfo[18], worldinfo[19], worldinfo[20], worldinfo[21], tempclr[2])
    -- Outline
    tempclr = attrib2colors (worldinfo[23])
    set_color (tempclr[1])
    set_bkcolor (tempclr[2])
    box (worldinfo[18], worldinfo[19], worldinfo[20], worldinfo[21])
    -- Header?
    if worldinfo[25] = 1 then
        locate (worldinfo[18], worldinfo[19] + 2)
        tempstr = "" & repeat ('', worldinfo[20]-worldinfo[18]-1) & ""
        txt (tempstr)        
        tempclr = attrib2colors (worldinfo[24])
        set_color (tempclr[1])
        set_bkcolor (tempclr[2])
        -- Fill 'title' area w. color
        locate (worldinfo[18]+1, worldinfo[19]+1)
        tempstr = repeat (' ', worldinfo[20]-worldinfo[18]-1)
        txt (tempstr)
        -- Title (clipped if too long)     
        maxmesglen = worldinfo[20] - worldinfo[18] - 3
        if length (title) > maxmesglen then
            title = title [1..maxmesglen]    
        end if              
        cpos = floor ((worldinfo [20]-length (title)+worldinfo[18]) / 2)+1 
        locate (cpos, worldinfo[19] + 1)
        txt (title)
    end if
    -- Pause
    junk = wait_key ()  
    -- Redraw everything
    draw_appropriate ()
end procedure

----------------------------------------------------------------------------
-- User edits colors / chars of message box
procedure edit_messagebox ()
    sequence back
    integer pointer, key, update, ppos
    pointer = 1                 
    update = 1
    ppos = 8
    back = save_text_image ({4, 10}, {21, 51})
    cursor (NO_CURSOR)
    display_text_image ({4, 10}, msgbox_screen)
    update_messagebox (ppos)
    while 1 do
        key = get_key ()
        if key = 27 then
            exit    
        end if        
        if key = k_up then
            locate (12, ppos)
            txt (" ")
            if pointer = 1 then
                pointer = 8
            else
                pointer = pointer - 1        
            end if     
            -- Update ppos ...   
            if pointer < 5 then
                ppos = pointer + 7
            elsif pointer < 8 then
                ppos = pointer + 8
            else
                ppos = 17
            end if
            update_messagebox (ppos)
        elsif key = k_down then
            locate (12, ppos)
            txt (" ")
            if pointer = 8 then
                pointer = 1
            else
                pointer = pointer + 1
            end if               
            -- Update ppos ...   
            if pointer < 5 then
                ppos = pointer + 7
            elsif pointer < 8 then
                ppos = pointer + 8
            else
                ppos = 17
            end if
            update_messagebox (ppos)
        elsif key = ' ' or key = 13 then
            do_edit_messagebox (pointer) 
            display_text_image ({4, 10}, msgbox_screen)
            update_messagebox (ppos)
        -- Preview! Whee!
        elsif key = 'P' or key = 'p' then
            preview_messagebox () 
            display_text_image ({4, 10}, msgbox_screen)
            update_messagebox (ppos)            
        end if
    end while                             
    display_text_image ({4, 10}, back)
    cursor (BLOCK_CURSOR)
end procedure                  

----------------------------------------------------------------------------
-- Shows the current block in blue for choosing a block
-- NOTE!!!: (SLOW / UNUSED)
procedure show_block (integer startx, integer starty, integer endx, integer endy)
    -- Show the actual block part ...
    for q = startx to endx do
        for z = starty to endy do
            do_right_char_color (15, 9, q, z)    
        end for
    end for
end procedure

----------------------------------------------------------------------------
-- Choose block for block functions
function choose_block ()
    sequence retval
    integer startx, starty, endx, endy, key
    startx = cx
    starty = cy             
    endx = cx
    endy = cy
    do_right_char_color (15, 9, cx, cy) 
    cursor (NO_CURSOR)
    while 1 do
        key = get_key ()
        if key = 27 or key = ' ' or key = 13 then
            exit    
        end if
        if key = k_up and endy > starty then  -- Up
            for q = startx to endx do
                do_right_char (q, endy)    
            end for
            endy = endy - 1     
        elsif key = k_down and endy < 25 then  -- Down
            endy = endy + 1
            for q = startx to endx do
                do_right_char_color (15, 9, q, endy)
            end for
        elsif key = k_left and endx > startx then  -- Left
            for q = starty to endy do
                do_right_char (endx, q)
            end for
            endx = endx - 1
        elsif key = k_right and endx < 60 then  -- Right
            endx = endx + 1
            for q = starty to endy do
                do_right_char_color (15, 9, endx, q)
            end for       
        elsif key = 408 then  -- Alt+Up
            for m = 1 to 5 do
                if endy = starty then
                    exit    
                end if
                for q = startx to endx do
                    do_right_char (q, endy)    
                end for
                endy = endy - 1                
            end for
        elsif key = 416 then  -- Alt+Down
            for m = 1 to 5 do 
                if endy = 25 then
                    exit    
                end if
                endy = endy + 1
                for q = startx to endx do
                    do_right_char_color (15, 9, q, endy)
                end for                
            end for
        elsif key = 411 then  -- Alt+Left 
            for m = 1 to 10 do    
                if endx = startx then
                    exit    
                end if
                for q = starty to endy do
                    do_right_char (endx, q)
                end for
                endx = endx - 1               
            end for
        elsif key = 413 then  -- Alt+Right   
            for m = 1 to 10 do 
                if endx = 60 then
                    exit    
                end if
                endx = endx + 1
                for q = starty to endy do
                    do_right_char_color (15, 9, endx, q)
                end for       
            end for           
        end if  
    end while      
    retval = {startx, starty, endx, endy, 0}             
    if key = 27 then 
        retval[5] = -1
        return retval
    else    
        return retval
    end if
end function

----------------------------------------------------------------------------
-- User selects block action to perform
function block_action ()
    integer pointer, key, update
    pointer = 1                   
    update = 1
    colorfill (15, 5, 46, 17, 1)
    locate (17, 6)
    txt ("@1~FBlock Function")  
    locate (17, 7)
    txt ("@1~9------") 
    locate (19, 9)
    txt ("~7( ) ~FCopy Block")
    locate (19, 10)
    txt ("~7( ) ~FCut Block") 
    locate (19, 11)
    txt ("~7( ) ~FDelete Block") 
    locate (19, 12)
    txt ("~7( ) ~FPaint Block") 
    locate (19, 13)
    txt ("~7( ) ~FFill Block")     
    locate (19, 14)
    txt ("~7( ) ~FExport Block")  
    locate (17, 16)
    txt ("~AEnter = Accept  ~CESC = Cancel")  
    txt ("@1~E")
    while 1 do              
        if update = 1 then
            locate (20, pointer + 8)
            txt ({7})    
        end if
        key = get_key ()
        if key = 27 or key = ' ' or key = 13 then
            exit    
        end if       
        if key = k_up then
            locate (20, pointer + 8)
            txt (" ")    
            if pointer = 1 then
                pointer = 6
            else
                pointer = pointer - 1    
            end if    
            update = 1
        end if
        if key = k_down then
            locate (20, pointer + 8)
            txt (" ")    
            if pointer = 6 then
                pointer = 1
            else
                pointer = pointer + 1    
            end if    
            update = 1
        end if
    end while          
    if key = 27 then
        return -1
    else
        return pointer
    end if  
end function    

----------------------------------------------------------------------------
-- Copies the block selected to the 'clipboard'
procedure grab2clipboard (sequence blockparam)
    
end procedure

----------------------------------------------------------------------------
-- MAIN block routine
procedure do_block ()
    object blockparam
    integer blockaction              
    -- 1st, they choose the block (bluevision)
    blockparam = choose_block ()              
    if blockparam[5] = 0 then             
        -- 2nd, if they don't press ESC, choose action
        blockaction = block_action () 
        -- 3rd, if they still don't press ESC, dooooooooo it!!                
        if blockaction > 0 then
            if blockaction = 1 then  -- Copy
                grab2clipboard (blockparam)
            end if    
        else              
            -- Get rid of marked area
            draw_appropriate ()
        end if                              
    else
        -- Get rid of marked area
        draw_appropriate ()
    end if    
end procedure

----------------------------------------------------------------------------
-- Fills in an area w. a specific char / obj
procedure floodfill (integer originalx, integer originaly)
    integer fillx, filly
    -- 'filly'? What's a horse have to do with anything? "SHADDAP!!!" Yikes!
    fillx = originalx
    filly = originaly   
end procedure

----------------------------------------------------------------------------
-- Sets player to new position! Funky.
procedure place_player ()
    -- First, remove teh (yes, teh) player from his/her/its old position
    -- (Notice the politically correctness ... yeah. Why are you reading
    -- this, anyways?! ^_^)
    for z = 1 to 60 do
        for p = 1 to 25 do
            if main [current_board] [z] [p] [1] = 9 then
                main [current_board] [z] [p] [1] = 0
                main [current_board] [z] [p] [2] = ' '
                main [current_board] [z] [p] [3] = 0
                main [current_board] [z] [p] [4] = 7
                main [current_board] [z] [p] [5] = 0
                locate (z, p)
                set_color (flr [current_board] [z] [p] [1])
                set_bkcolor (flr [current_board] [z] [p] [2])
                txt ({flr [current_board] [z] [p] [3]})                                    
            end if
        end for
    end for                  
    -- Then, set the player to his/her/its new position! Fwee!
    main [current_board] [cx] [cy] [1] = 9
    main [current_board] [cx] [cy] [2] = worldinfo [5]
    main [current_board] [cx] [cy] [3] = 0
    main [current_board] [cx] [cy] [4] = worldinfo [9]
    main [current_board] [cx] [cy] [5] = worldinfo [10]
    set_color (worldinfo [9])
    if worldinfo [10] = 0 then  
        set_bkcolor (flr [current_board] [cx] [cy] [2])     
    else
        set_bkcolor (worldinfo [10])         
    end if
    locate (cx, cy)
    txt ({worldinfo [5]})   
end procedure

----------------------------------------------------------------------------
-- Saves a .DOG file to disk!
procedure save_world ()
    object fname, ref
    file_number fout
    fname = ""         
    ref = {}
    display_text_image ({7, 15}, save_scrn)
    locate (17, 11)
    txt ("@1~FFilename: @4")
    fname = getstr (27, 11, 8)        
    if atom (fname) = 0 then
    if compare (fname, "") = 1 then  -- If they don't just press Enter ...
        fname = fname & ".dog"       
        worldinfo[3] = upper (fname)
        cursor (NO_CURSOR)
        colorfill (15, 7, 46, 12, 4)
        locate (17, 9)
        txt ("@4~FSaving")
        locate (17, 10)
        txt ("~C------") 
        -----------
        -- Save it!
        fout = open (fname, "w")  
        puts (fout, worldheader)
        print (fout, worldinfo)
        print (fout, boardinfo)
        -- Save all the floors
        for z = 1 to worldinfo [4] do
            for m = 1 to 25 do
                for b = 1 to 60 do
                    puts (fout, flr[z][b][m][3])
                    puts (fout, flr[z][b][m][1] + (flr[z][b][m][2] * 16))
                end for
            end for
        end for
        -- Save all 'main's (yes, main's) except ref #'s
        for z = 1 to worldinfo [4] do
            for m = 1 to 25 do
                for b = 1 to 60 do                                   
                    puts (fout, main[z][b][m][2])
                    puts (fout, main[z][b][m][3])
                    puts (fout, main[z][b][m][4] + (main[z][b][m][5] * 16))
                end for
            end for
        end for
        -- Save ref #'s as a sequence to allow 255+ robots
        for z = 1 to worldinfo [4] do
            for m = 1 to 25 do
                for b = 1 to 60 do  
                    ref = append (ref, main[z][b][m][1])                        
                end for                                   
            end for            
        end for
        print (fout, ref)
        -- Save all the overlays
        for z = 1 to worldinfo [4] do
            if boardinfo[z][9] > 0 then
            puts (fout, '1')
            for m = 1 to 25 do
                for b = 1 to 60 do
                    puts (fout, overlay[z][b][m][3])
                    puts (fout, overlay[z][b][m][1] + (overlay[z][b][m][2] * 16))
                end for
            end for
            else  
            puts (fout, '0')
            end if
        end for                  
        -- Save all the overlay2s
        for z = 1 to worldinfo [4] do
            if boardinfo[z][10] > 0 then
            puts (fout, '1')
            for m = 1 to 25 do
                for b = 1 to 60 do
                    puts (fout, overlay2[z][b][m][3])
                    puts (fout, overlay2[z][b][m][1] + (overlay2[z][b][m][2] * 16))
                end for
            end for
            else  
            puts (fout, '0')
            end if
        end for
        -- Save palette
        print (fout, curr_palette)
        -- Close it up!
        close (fout)
    end if        
    end if
    draw_appropriate ()
    draw_sidebar ()   
end procedure        

----------------------------------------------------------------------------
-- Loads a .DOG file from disk 
procedure load_world ()               
    integer tmp, cnt
    object fname, tempseq
    file_number fin
    fname = ""      
    cnt = 0
    --display_text_image ({7, 15}, load_scrn)
    --locate (17, 11)
    --txt ("@1~FFilename: @4")
    --fname = getstr (27, 11, 8)
    fname = dirlist ("Corndog World", "*.dog")        
    if atom (fname) = 0 then
    if compare (fname, "") = 1 then  -- If they don't just press Enter ...
        cursor (NO_CURSOR)
        colorfill (15, 7, 46, 12, 4)
        locate (17, 9)
        txt ("@4~FLoading")
        locate (17, 10)
        txt ("~C------") 
        --fname = fname & ".dog"       
        -- Load it!
        fin = open (fname, "r")  
        tempseq = gets (fin)
        if compare (tempseq, worldheader) = 0 then
            -- Get world/board info ... 'easy' stuff. ;)
            tempseq = get (fin)
            worldinfo = tempseq [2]
            tempseq = get (fin)
            boardinfo = tempseq [2]
            -- Get floor info
            for z = 1 to worldinfo [4] do
                for m = 1 to 25 do
                    for b = 1 to 60 do
                        flr[z][b][m][3] = getc (fin)
                        tmp = getc (fin)  
                        tempseq = attrib2colors (tmp)
                        flr[z][b][m][1] = tempseq [1]
                        flr[z][b][m][2] = tempseq [2]
                    end for
                end for
            end for            
            -- Get 'main' info
            for z = 1 to worldinfo [4] do
                for m = 1 to 25 do
                    for b = 1 to 60 do
                        main[z][b][m][2] = getc (fin)
                        main[z][b][m][3] = getc (fin)   
                        tmp = getc (fin)
                        tempseq = attrib2colors (tmp)
                        main[z][b][m][4] = tempseq [1]
                        main[z][b][m][5] = tempseq [2]
                    end for
                end for
            end for  
            -- Get ref #'s for main   
            tempseq = get (fin)
            for z = 1 to worldinfo [4] do
                for m = 1 to 25 do
                    for b = 1 to 60 do
                        cnt = cnt + 1
                        main[z][b][m][1] = tempseq [2][cnt]      
                    end for
                end for
            end for          
            -- Get overlay info
            for z = 1 to worldinfo [4] do
                tmp = getc (fin)
                if tmp = '1' then
                for m = 1 to 25 do
                    for b = 1 to 60 do
                        overlay[z][b][m][3] = getc (fin)
                        tmp = getc (fin)  
                        tempseq = attrib2colors (tmp)
                        overlay[z][b][m][1] = tempseq [1]
                        overlay[z][b][m][2] = tempseq [2]
                    end for
                end for
                else
                overlay [z] = repeat (repeat ({7, 0, ' '}, 25), 60)
                end if
            end for       
            -- Get overlay2 info
            for z = 1 to worldinfo [4] do
                tmp = getc (fin)
                if tmp = '1' then
                for m = 1 to 25 do
                    for b = 1 to 60 do
                        overlay2[z][b][m][3] = getc (fin)
                        tmp = getc (fin)  
                        tempseq = attrib2colors (tmp)
                        overlay2[z][b][m][1] = tempseq [1]
                        overlay2[z][b][m][2] = tempseq [2]
                    end for
                end for
                else
                overlay2 [z] = repeat (repeat ({7, 0, ' '}, 25), 60)
                end if
            end for     
            -- Get palette   
            tempseq = get (fin)
            curr_palette = tempseq [2]      
            all_palette (curr_palette)
            -- Close it up!        
            close (fin)                
            -- Load MOD if any ... <==EDIT THIS
            if compare (boardinfo[1][7], "None") != 0 then        
                unload_mod ()
                junk = init_modwave (STEREO, 44100, 20)        
                volume_up ()               
                junk = load_mod (boardinfo[1][7]) 
            end if                                        
            current_board = 1   
            current_layer = 0
            reset_current_obj ()
            draw_appropriate ()
            draw_sidebar ()   
        else
            draw_appropriate ()
        end if
    end if  
    end if
end procedure

----------------------------------------------------------------------------
-- If obj being placed is same as what's already there, del it, like MZX
procedure check_place_overwrite ()                                      
    if current_layer = -1 then  -- Floor
        if current_char = flr[current_board][cx][cy][3] and
            current_color = flr[current_board][cx][cy][1] and
            current_bkcolor = flr[current_board][cx][cy][2] then
            flr[current_board][cx][cy][1] = 7
            flr[current_board][cx][cy][2] = 0
            flr[current_board][cx][cy][3] = ' '
            --locate (cx, cy)
            do_right_char (cx, cy)
        else
            place_current ()
        end if
    elsif current_layer = 0 and current_ref = 0 then  -- Main
        if current_type = main[current_board][cx][cy][1] and  
            current_char = main[current_board][cx][cy][2] and
            current_color = main[current_board][cx][cy][4] and
            current_bkcolor = main[current_board][cx][cy][5] then
            main[current_board][cx][cy][1] = 0
            main[current_board][cx][cy][2] = ' '
            main[current_board][cx][cy][3] = 0
            main[current_board][cx][cy][4] = 7
            main[current_board][cx][cy][5] = 0
            --locate (cx, cy)
            do_right_char (cx, cy)
        else
            place_current ()
        end if
    elsif current_layer = 1 then  -- Overlay
        if current_char = overlay[current_board][cx][cy][3] and
            current_color = overlay[current_board][cx][cy][1] and
            current_bkcolor = overlay[current_board][cx][cy][2] then
            overlay[current_board][cx][cy][1] = 7
            overlay[current_board][cx][cy][2] = 0
            overlay[current_board][cx][cy][3] = ' '
            --locate (cx, cy)
            do_right_char (cx, cy)
        else
            place_current ()            
        end if
    elsif current_layer = 2 then  -- Overlay2
        if current_char = overlay2[current_board][cx][cy][3] and
            current_color = overlay2[current_board][cx][cy][1] and
            current_bkcolor = overlay2[current_board][cx][cy][2] then
            overlay2[current_board][cx][cy][1] = 7
            overlay2[current_board][cx][cy][2] = 0
            overlay2[current_board][cx][cy][3] = ' '
            --locate (cx, cy)
            do_right_char (cx, cy)
        else
            place_current ()            
        end if        
    else  -- Really, it should never get to this 'else' ...
        place_current ()
    end if
end procedure

----------------------------------------------------------------------------
-- Main movement / thingie ...
procedure move_cursor () 
    object key       
    drawing = 0
    key = -1
    cursor (BLOCK_CURSOR)
    locate (cx, cy)
    while key != 27 do
        -- Movement
        if key != -1 then
        if key = k_up and cy > 1 then  -- Up
            cy = cy - 1
            check_drawing ()
        elsif key = k_down and cy < 25 then  -- Down
            cy = cy + 1    
            check_drawing ()
        elsif key = k_left and cx > 1 then  -- Left
            cx = cx - 1
            check_drawing ()
        elsif key = k_right and cx < 60 then  -- Right
            cx = cx + 1
            check_drawing ()
        -- FAST movement (+ALT)
        elsif key = 408 then  -- Alt-Up
            if cy < 6 and cy != 1 then
                for z = cy to 1 by -1 do
                    cy = z
                    check_drawing ()
                end for
            elsif cy != 1 then
                for z = cy to cy - 5 by -1 do
                    cy = z
                    check_drawing ()
                end for    
            end if
        elsif key = 416 then  -- Alt-Down
            if cy > 20 and cy != 25 then
                for z = cy to 25 by 1 do
                    cy = z
                    check_drawing ()
                end for
            elsif cy != 25 then
                for z = cy to cy + 5 by 1 do
                    cy = z
                    check_drawing ()
                end for    
            end if
        elsif key = 411 then  -- Alt-Left
            if cx < 11 and cx != 1 then
                for z = cx to 1 by -1 do
                    cx = z
                    check_drawing ()
                end for
            elsif cx != 1 then
                for z = cx to cx - 10 by -1 do
                    cx = z
                    check_drawing ()
                end for
            end if
        elsif key = 413 then  -- Alt-Right
            if cx > 50 and cx != 60 then
                for z = cx to 60 by 1 do
                    cx = z
                    check_drawing ()
                end for
            elsif cx != 60 then
                for z = cx to cx + 10 by 1 do
                    cx = z
                    check_drawing ()
                end for                
            end if                      
        -- spacebar: Place current object!
        elsif key = 32 and main[current_board][cx][cy][1] != 9 then
            check_place_overwrite ()
        -- ins: Grab object
        elsif key = 338 then
            grab_obj ()
        -- C: Choose color
        elsif key = 'C' or key = 'c' then
            if current_type != 0 then
                junk = choose_color ({current_color, current_bkcolor})
                if junk [1] != -1 then
                    current_color = junk [1]
                    current_bkcolor = junk [2]
                    show_current ()    
                end if
            end if
        -- tab: Drawing toggle
        elsif key = 9 then
            if drawing = 0 then
                locate (62, 19)
                txt ("@1~E Drawing ON ")
                drawing = 1
                check_drawing ()
            else
                locate (62, 19)
                txt ("@1~8 Drawing OFF")
                drawing = 0    
            end if
        -- enter: Choose char            
        elsif key = 13 then
            if current_type != 0 then
                junk = choose_char (current_char, current_color, current_bkcolor)        
                if junk != -1 then
                    current_char = junk
                    show_current ()    
                end if
            end if
        -- F4: Choose type (only for 'main')
        elsif key = 318 and current_layer = 0 then
            choose_type ()
        -- `: Redraw board
        elsif key = 96 then
            draw_appropriate ()
        -- F5: Type text   
        elsif key = 319 then
            type_text ()
        -- PgDown: Go down a layer if possible
        elsif key = 337 then            
            if current_layer > -1 then
                current_layer = current_layer - 1
                reset_current_obj () 
                show_current () 
                draw_appropriate ()
            end if          
        -- PgUp: Go up a layer if possible
        elsif key = 329 then              
            if current_layer < boardinfo[current_board][8] then
                current_layer = current_layer + 1
                reset_current_obj () 
                show_current () 
                draw_appropriate ()    
            end if
            clear_buff ()   
        -- P: Place player to new position on current board
        elsif key = 'P' or key = 'p' and current_layer = 0 then
            place_player ()         
        -- I: Edit board info
        elsif key = 'I' or key = 'i' then
            board_info ()        
        -- A: Add new board! Durrrrr
        elsif key = 'A' or key = 'a' then
            add_board ()
            draw_appropriate ()      
            reset_current_obj ()
            draw_sidebar ()               
        -- +/=: Advance by one board! Fwee!
        elsif key = '+' or key = '=' and current_board < worldinfo[4] then
            if compare (boardinfo[current_board][7], "None") != 0 and
               compare (boardinfo[original][7], boardinfo[junk][7]) != 0 then
                unload_mod ()    
            end if
            current_board = current_board + 1                               
            if compare (boardinfo[current_board][7], "None") != 0 and
               compare (boardinfo[original][7], boardinfo[junk][7]) != 0 then
                junk = init_modwave (STEREO, 44100, 20)        
                volume_up ()               
                junk = load_mod (boardinfo[current_board][7])    
            end if
            draw_appropriate ()
            locate (62, 15)
            txtf ("@1~ABoard: %d~2 / ~A%d  ", {current_board, worldinfo[4]})
        -- -/_: Uh, 'devance' by one board! Yeah! That's a word!
        elsif key = '-' or key = '_' and current_board > 1 then
            if compare (boardinfo[current_board][7], "None") != 0 and
               compare (boardinfo[original][7], boardinfo[junk][7]) != 0 then
                unload_mod ()    
            end if
            current_board = current_board - 1
            if compare (boardinfo[current_board][7], "None") != 0 and
               compare (boardinfo[original][7], boardinfo[junk][7]) != 0 then
                junk = init_modwave (STEREO, 44100, 20)        
                volume_up ()               
                junk = load_mod (boardinfo[current_board][7])    
            end if
            draw_appropriate ()
            locate (62, 15)
            txtf ("@1~ABoard: %d~2 / ~A%d  ", {current_board, worldinfo[4]})
        -- B: Change boards via list
        elsif key = 'B' or key = 'b' then     
            junk = -2
            while junk = -2 do
            original = current_board
            junk = select_board (current_board)
            if junk > -1 then
                if compare (boardinfo[original][7], "None") != 0 and 
                   compare (boardinfo[original][7], boardinfo[junk][7]) != 0 then
                    unload_mod ()    
                end if
                current_board = junk
                if compare (boardinfo[current_board][7], "None") != 0 and 
                   compare (boardinfo[original][7], boardinfo[current_board][7]) != 0 then
                    junk = init_modwave (STEREO, 44100, 20)        
                    volume_up ()               
                    junk = load_mod (boardinfo[current_board][7])    
                end if
                draw_appropriate ()
                draw_sidebar ()
            elsif junk = -2 then
                junk = select_board (current_board)                
            end if            
            end while
        -- Z: Clear current board to 'blank'
        elsif key = 'Z' or key = 'z' then
            clear_board () 
            draw_appropriate ()
        -- *: Clear _all_
        elsif key = '*' then
            user_clear_all ()       
        -- W: Edit world info
        elsif key = 'W' or key = 'w' then
            world_info ()
            draw_appropriate ()
        -- S: Save world file
        elsif key = 'S' or key = 's' or key = 317 then
            save_world () 
        -- L: Load world file
        elsif key = 'L' or key = 'l' or key = 316 then
            load_world ()   
        -- O: Turn overlay(s) on/off/transparent
        elsif key = 'O' or key = 'o' then
            toggle_overlays ()
        -- M: Edit message box / stuff! Yes!    
        elsif key = 'M' or key = 'm' then            
            edit_messagebox ()        
        -- 2: World info 2
        elsif key = '2' then            
            junk = world_info2 ()
        -- Alt-M: Mark a block
        elsif key = 306 then
            do_block ()  
        -- Alt-P (or Alt-E): Edit palette(s)
        elsif key = 281 or key = 274 then
            palette_edit () 
        -- Alt-C: Char editor
        elsif key = 302 then            
            char_edit ()
        end if
        cursor (NO_CURSOR)
        locate (62, 4)
        txtf ("@1~4(~C%d~4, ~C%d~4)  ", {cx, cy}) 
        locate (cx, cy)
        cursor (BLOCK_CURSOR)  
        end if  -- This 'end if' goes w. the inital keycheck :)
        key = get_key ()  
    end while
end procedure

----------------------------------------------------------------------------
----------------------------------------------------------------------------
-- Main Routine

clear_screen ()

wrap (0)

-- Why does this work? I dunno ... but it does. :)  
intense (0)    
setup_images ()
egachars ()
allow_all_paledit ()          
all_palette (default_palette)
intense (0)    

clear_world ()
draw_sidebar ()
draw_all_board ()     
move_cursor ()

----------------------------------------------------------------------------
-- Cleanup     

unload_mod ()
close_modwave ()                
set_color (7)           
set_bkcolor (0)
cursor (UNDERLINE_CURSOR)
clear_screen ()

-- The End. ^_^                                                             

----------------------------------------------------------------------------
----------------------------------------------------------------------------

